<?php
/**
 * Enter description here ...
 *
 * @package Logic
 *
 * @author  alessandrobartels
 */
class Preparacao{

    /* @todo variaveis de ambiente */
    private $_simulacao;

    /**
     * @var Parametros
     */
    private $_parametros;

    private $_nrorg;
    private $_nrOrgPadrao;
    private $_nrTipoModalidadeCalc;
    private $_nrOcorrenciaCalc;

    /* private $dias_afastados; */
    private $_nr_tipo_calculo;
    private $_jornada_diaria; /* utilizado somente no inicializa variaveis e nao mais usado*/
    private $_tipo_movimento; /* Nao usado */
    /** @var TkDateTime  */
    private $_mes_competencia;
    private $_mes_competencia_int; // Somente o mes - BORBA 07/07/2014
    private $_id_retrocesso;
    private $_dtInicio;
    private $_dtFim;
    private $_dtPagamento;
    /* Aviso */
    private $_inicio_periodo_aviso;
    private $_fim_periodo_aviso;
    private $_nr_dias_aviso;
    private $_nr_compl_dias_aviso;    // Borba 23/02/2013
    private $_12_meses_atras;         // Borba 20/02/2013
    private $_divisor_aviso; // Borba 30/10/2013
    /* Contratos */
    private $_dt_fim_exp1; // Borba 07/08/2013
    private $_dt_fim_exp2; // Borba 07/08/2013

    /* 13 Salario */
    private $_nr_dias_faltas; //BORBA 03/12/2013 Não identificado o uso
    /** @var TkDateTime */
    private $_inicio_periodo_13sal;
    private $_fim_periodo_13sal;
    private $_ultimo_dia_mes;
    private $_primeiro_dia_ano;
    private $_ultimo_dia_ano;
    private $_nr_doze_avos;
    private $_nr_compl_doze_avos;      // Borba 23/02/2013
    private $_divisor_13; // Borba 30/10/2013

    private $_percentual_adiantamento = 50;

    /* Ferias */
    private $_inicio_periodo_saida;
    private $_fim_periodo_saida;
    private $_tipo_ferias;  /* nao usado */
    /** @var $ferias FpaferiasEntity */
    private $_ferias;
    /** @var FpaGozoferiasEntity */
    private $_gozo_ferias;
    private $_aviso_previo;  // Borba 20/02/2013
    private $_ferias_vencidas;
    private $_ferias_proporcionais;
    private $_divisor_ferias; // Borba 30/10/2013
    private $_decimo_terceiro_sal;

    //BORBA 06/02/2014 Utilizados para lançamento de gozo e abertura de proximo periodo aquisitivo em caso de Fer Coletivas
    /* Ferias Coletivas */
    private $_dt_retorno_ferias;
    private $_dt_ini_prox_periodo;
    private $_ds_ferias_coletivas;
    private $_nr_situ_func;
    private $_id_ferias_coletivas;

    /* Objetos */
    /** @var FpaItecalcfolhaEntity */ //BORBA 20/02/2013
    private $_itens_calculo_principal;
    // Itens de calculos usados em Rescisao e Provisao.
    private $_itens_aviso_previo;    // Borba 20/02/2013
    private $_itens_ferias_vencidas;
    /** @var FpaItecalcfolhaEntity */ //BORBA 11/12/2014
    private $_itens_ferias_proporcionais;
    private $_itens_13sal;

    private $_calculo_folha; /* atribuido somente no construtor e nao mais usado */
    /** @var $_assoc_eventos \FpaassoceventoEntity */
    private $_assoc_eventos;
    private $_eventom;
    private $_eventomMedia;
    private $_vinculom; /* atribuido somente no construtor e nao mais usado */
    private $_pessoa;
    private $_escalam; /* utilizado somente no inicializa variaveis e nao mais usado*/
    private $_situacao_funcional;
    private $_alteracao_situacao_funcional;
    private $_media;

    private $_paramCalculo;
    private $_vrPercentAdiant13Sal;
    private $_nrDiasFeriasProvisao;
    private $_faltas_intervalo;



    /**
     * Enter description here ...
     *
     * @param Parametros $parametro     Instancia de Parametros.
     * @param TkEntity   $formulario    Instancia de TkEntity (Pode variar em FpaFormcalculoEntity ou FormFeriasEntity).
     * @param integer    $nr_tp_calculo Numero do Tipo de Calculo.
     * @param boolean    $simulacao     Flag de simulacao de calculo.
     * @param string     $idRetrocesso  Flag de retrocesso de calculo.
     */
    public function __construct(
        Parametros $parametro, TkEntity $formulario, $nr_tp_calculo, $simulacao, $idRetrocesso
    ){

        $this->_parametros = $parametro;

        $this->_nrorg = $this->_parametros->getNrOrgTrabalho();
        $this->_nrOrgPadrao = $this->_parametros->getNrOrgPadrao();
        $this->_mes_competencia = $this->_parametros->getMesCompetencia();
        $this->_nrTipoModalidadeCalc = $this->_parametros->getTipoModalidadeCalculo();
        $this->_nrOcorrenciaCalc = $this->_parametros->getNrOcorrenciaCalculo();
        //BORBA 07/07/2014
        $this->_mes_competencia_int = $this->_mes_competencia->toValue(TkDateTime::MONTH);
        $this->_dtPagamento = $formulario->getDtpagamento();

        /* A preparacao quando chamada do calculo passa idRetrocesso como "false".
         * O idRetrocesso eh um dado de formulario.*/
        $this->_id_retrocesso = $idRetrocesso;

        $this->_simulacao = $simulacao;
        $this->_nr_tipo_calculo = $nr_tp_calculo;

        switch ($this->_nr_tipo_calculo)
        {
            case FpatipocalculoEntity::CALC_13SAL:
            case FpatipocalculoEntity::CALC_ADIANT_13SAL:

                $this->_primeiro_dia_ano = new TkDateTime($this->_mes_competencia, TkDateTime::FORMAT_DATE);
                $this->_primeiro_dia_ano->setDay(1)->setMonth(1);
                $this->_ultimo_dia_ano = new TkDateTime($this->_mes_competencia, TkDateTime::FORMAT_DATE);
                $this->_ultimo_dia_ano->setMonth(12)->setDay(31);
                break;

            case FpatipocalculoEntity::CALC_FERIAS:
                /* Tipo de ferias  esta instanciado dentro de ferias */
                $this->_ferias = TkDI::getContainer()->ferias;
                $this->_gozo_ferias = TkDI::getContainer()->gozo_ferias;
                $this->_dtInicio = $formulario->getDtinigozoini();
                $this->_dtFim = $formulario->getDtinigozofim();
                $this->_inicio_periodo_saida = new TkDateTime($this->_dtInicio, TkDateTime::FORMAT_DATE);
                $this->_fim_periodo_saida = new TkDateTime($this->_dtFim, TkDateTime::FORMAT_DATE);
                $this->_primeiro_dia_ano = new TkDateTime($this->_mes_competencia, TkDateTime::FORMAT_DATE);
                $this->_primeiro_dia_ano->setDay(1)->setMonth(1);
                $this->_ultimo_dia_ano = new TkDateTime($this->_mes_competencia, TkDateTime::FORMAT_DATE);
                $this->_ultimo_dia_ano->setMonth(12)->setDay(31);
                //BORBA 07/02/2014 Testa se $formulario é um formulario de ferias coletivas entes de setar atributos específicos
                if($formulario instanceof \Folha\Entities\FpaFormferiascolet){
                    $this->_dt_retorno_ferias=$formulario->getDtretornoferias();
                    $this->_dt_ini_prox_periodo=$formulario->getDtiniperaquistivo();
                    $this->_ds_ferias_coletivas=$formulario->getDsferiascolet();
                    $this->_nr_situ_func=$formulario->getNrsitufuncm();
                    $this->_id_ferias_coletivas=True;
                }
                break;

            case FpatipocalculoEntity::CALC_RESCISAO:
            case FpatipocalculoEntity::CALC_RESCISAO_COMPLEMENTAR:
            case FpatipocalculoEntity::CALC_PROVISAO_CONTABIL:
                $this->_ferias = TkDI::getContainer()->ferias;
                $this->_ultimo_dia_mes = new TkDateTime($this->_mes_competencia);
                $this->_ultimo_dia_mes->addMonth(1)->setDay(1)->subDay(1);
                $this->_primeiro_dia_ano = new TkDateTime($this->_mes_competencia);
                $this->_primeiro_dia_ano->setDay(1)->setMonth(1);
                $this->_ultimo_dia_ano = new TkDateTime($this->_mes_competencia);
                $this->_ultimo_dia_ano->setMonth(12)->setDay(31);
                $this->_12_meses_atras = new TkDateTime($this->_mes_competencia);
                //Utilizado -11 para chegar ao valor real a se deduzir da data do mês corrente
                //01/02/2013 - 11 meses = 01/03/2012 porque fevereiro de 13 entra na média.
                $this->_12_meses_atras->addMonth(-11);
                //tk_warning($this->_12_meses_atras->toString(TkDateTime::FORMAT_DATE));
                break;
        }

        $this->_media = new MediaEventosIntervalo(
            $this->_nrorg, $this->_nrOrgPadrao, $this->_mes_competencia, $this->_dtPagamento
        );

        $this->_eventomMedia = new FpaeventomEntity(
            null, $this->_nrorg, $this->_nrOrgPadrao, $this->_mes_competencia, $this->_dtPagamento
        );

        /* Container */
        $this->_vinculom = TkDI::getContainer()->vinculom;
        $this->_pessoa = TkDI::getContainer()->pessoa;
        $this->_assoc_eventos = TkDI::getContainer()->assoc_eventos;
        $this->_eventom = TkDI::getContainer()->eventom;
        $this->_escalam = TkDI::getContainer()->escalam;
        $this->_situacao_funcional = TkDI::getContainer()->situacao_funcional;
        $this->_alteracao_situacao_funcional = TkDI::getContainer()->alteracao_situacao_funcional;
        $this->_calculo_folha = TkDI::getContainer()->calculo_folha;
        $this->_paramCalculo = TkDI::getContainer()->param_calculo;
        $this->_faltas_intervalo = TkDI::getContainer()->faltas_intervalo;
    }


    /**
     * Enter description here ...
     *
     * @param string        $vinculo       V�nculo.
     * @param string        $tp_calc_mov   Tipo C�lculo Movimento.
     * @param Demonstrativo $demonstrativo Instancia de Demonstrativo.
     * @param integer       $contador      Contador.
     *
     * @throws Exception E.
     *
     * @return void
     */
    public function preparar($vinculo, $tp_calc_mov, Demonstrativo $demonstrativo, $contador){
        $this->_inicializaVariaveis($vinculo);
        if ($tp_calc_mov->retornaItensCalculo($vinculo) === false) {
            return;
        }

        try{
            $obj_tp_calc_mov = current($tp_calc_mov->retornaPosicaoTpMov($tp_calc_mov->retornaTpMovPrincipal()));
            $this->_itens_calculo_principal =  $obj_tp_calc_mov->getInstancia();
        } catch(Exception $e){
            $message = $e->getMessage().' - Principal PREPARACAO.PHP';
            throw new Exception($message);
        }

        /* Verifica a existencia de liquido para nao executar a preparacao novamente. A preparacao nao pode recalcular
         * os eventos que ja foram calculados pelo mensal. O certo eh retroceder o mensal, retroceder a preparacao e
         * assim realizar uma nova preparacao.
         */

        // BORBA 25/08/2014
        if ($this->_nr_tipo_calculo !== FpatipocalculoEntity::CALC_FECHAMENTO &&
            $this->_nr_tipo_calculo !== FpatipocalculoEntity::CALC_PROVISAO_CONTABIL){//BORBA 22/08/2014 ANTES TESTAVA SOMENTE FECHAMENTO
            $liquido = $this->_itens_calculo_principal->verificaLiquido(
                $this->_assoc_eventos, $this->_eventom, $this->_nrorg
            );
            if ($liquido === true) {
                //@todo MsgCalculo
                MsgCalculo::getInstance()->adicionaMensagem('Vínculo possui líquido.',MsgCalculo::ALERTA);
                //tk_warning('PREPARACAO - Vinculo '.$vinculo->getNrvinculom().' '.$vinculo->getNmvinculom().' possui liquido');
                return false;
            }
        }

        /* Verifica a existencia de liquido parcial.
         * Retrocede os eventos caso exista, e executa a preparacao novamente.
         */
        $liquidoParcial = $this->_itens_calculo_principal->verificaLiquidoParcial(
            $this->_assoc_eventos, $this->_eventom, $this->_nrorg
        );
        if ($liquidoParcial === true) {
            $this->_itens_calculo_principal->executaRetrocesso($this->_eventom);
        }

        if ($this->_id_retrocesso === true) {
            $this->_retrocesso($tp_calc_mov);
        }
        //BORBA 07/02/2014
        if($this->_id_ferias_coletivas==true){
            $this->_verificaFeriasColetivas($vinculo,$this->_inicio_periodo_saida,$this->_fim_periodo_saida,$this->_dt_retorno_ferias,
                                            $this->_dt_ini_prox_periodo,$this->_ds_ferias_coletivas);
        }
        $this->_executaPreparacaoEspecifica($vinculo, $tp_calc_mov);

        if ($this->_simulacao === false) {
            $tp_calc_mov->persisteItensCalculo();
            return;
        } else {
            $elementoDemonstrativo = $this->_preparaCabecalho($vinculo, $demonstrativo, $contador);

            $lista = $tp_calc_mov->retornaListaItensCalculo(
                $this->_mes_competencia, $this->_eventom, $elementoDemonstrativo
            );
            return $lista;
        }

    }


    /**
     * Enter description here ...
     *
     * @param GpevinculomEntity  $vinculo     Instancia de GpevinculomEntity.
     * @param FpatpcalcmovEntity $tp_calc_mov Instancia de FpatpcalcmovEntity.
     *
     * @throws Exception E.
     *
     * @return void
     *
     * @author alessandrobartels
     */
    private function _executaPreparacaoEspecifica(GpevinculomEntity $vinculo, FpatpcalcmovEntity $tp_calc_mov){

        switch($this->_nr_tipo_calculo){
            case FpatipocalculoEntity::CALC_ADIANT_PLR:
            case FpatipocalculoEntity::CALC_PLR:
                $this->_analisaPLR($vinculo,$this->_itens_calculo_principal);
                break;
            case FpatipocalculoEntity::CALC_13SAL:
            case FpatipocalculoEntity::CALC_ADIANT_13SAL:
                $this->_analisa13Sal($vinculo, $this->_itens_calculo_principal);
                break;
            case FpatipocalculoEntity::CALC_FERIAS:
                $this->_analisaFerias($vinculo);
                break;
            case FpatipocalculoEntity::CALC_RESCISAO:
            case FpatipocalculoEntity::CALC_RESCISAO_COMPLEMENTAR:
            case FpatipocalculoEntity::CALC_PROVISAO_CONTABIL:

                try {
                    $this->_atribuiIteCalcEspecificoRescisao($tp_calc_mov);
                } catch(Exception $e){
                    throw $e;
                }

                $this->_analisaFimContrato($vinculo,$this->_itens_calculo_principal); //BORBA 07/08/2013
                // O aviso prévio é feito primeiro para refletir nas ferias e decimo terceiro
                //BORBA 13/08/2013 - MOVIDO TEMPORÁRIAMENTE PARA DENTRO DO _analisaFimContrato
                //$this->_analisaAvisoPrevio($vinculo, $this->_itens_aviso_previo); //BORBA 20/02/2013
                $this->_analisaFeriasRescisaoProvisao($vinculo, $tp_calc_mov);
                $this->_analisa13Sal($vinculo, $this->_itens_13sal);
                break;

            default:
                /* @todo Tratar preparacao generica do usuario */
                //@todo MsgCalculo
                MsgCalculo::getInstance()->adicionaMensagem('Nr Tipo de calculo invalido',MsgCalculo::ERRO,true);
                //tk_warning('<<PREPARACAO>> Nr Tipo de calculo invalido');
//                die();
        }
    }


    /**
     * Enter description here ...
     *
     * @param GpevinculomEntity  $vinculo     Instancia de GpevinculomEntity.
     * @param FpatpcalcmovEntity $tp_calc_mov Instancia de FpatpcalcmovEntity.
     *
     * @return void
     */
    public function retroceder(GpevinculomEntity $vinculo, FpatpcalcmovEntity $tp_calc_mov){
        /* @todo rever processo
        O retrocesso da preparacao de rescisao nao pode retroceder o mensal
        criar controles no tpcalcmov (retrocede calculo, retrocede preparacao) */
        if ($tp_calc_mov->retornaItensCalculo($vinculo) === false) {
            throw new Exception($vinculo->getNrvinculom().' Não encontrou itens de calculo - PREPARACAO');
        }

        $this->_retrocesso($tp_calc_mov);
        tk_warning('Vinculo: '.$vinculo->getNrvinculom().' '.$vinculo->getNmvinculom().' Retrocedeu - PREPARACAO');
        /* $tp_calc_mov->persisteItensCalculo(); */

    }


    /**
     * Enter description here ...
     *
     * @param FpatpcalcmovEntity $tp_calc_mov Instancia de FpatpcalcmovEntity.
     *
     * @return void
     */
    private function _retrocesso(FpatpcalcmovEntity $tp_calc_mov){
        /* O retrocesso da preparacao diferente do retrocesso do calculo nao testa nada no evento
         Os itens sao apagados como se o vinculo nao fosse mais gozar ferias ou receber 13� ou ser demitido
         */
        $tp_calc_mov->apagaItensCalculo();
    }


    /**
     * Enter description here ...
     *
     * @param GpevinculomEntity $vinculo Instancia de Vinculo.
     *
     * @return void
     */
    private function _inicializaVariaveis(GpevinculomEntity $vinculo){
        $escala = $this->_escalam->retornaEscala($vinculo->historico->getNrescalatrabm(), $this->_nrorg);
        $this->_jornada_diaria = $escala->historico->getQthrescalatrabh();

        $nrEstrutura = $vinculo->historico->getNrestrutlegal();
        if ($nrEstrutura === null) {
            $this->_nrCalendario = null;
            $msg = 'Vinculo '.$vinculo->getNrvinculom().' sem parametrizacao de Estrutura Legal. ';
            $msg .= '<br/> Preparacao nao executada.';
            //@todo MsgCalculo
            MsgCalculo::getInstance()->adicionaMensagem('Vínculo sem parametrização de Estrutura Legal.');
            //tk_warning($msg);
            return;
        }

        // Carrega na lista Parametro de Estrutura.
        $this->_paramCalculo->carregaParametroEstrutura($nrEstrutura);

        // Carrega o Parametro de Ferias.
        $this->_carregaParametroFerias();

    }


    /**
     * Carrega o parametro de ferias.
     *
     * @throws Exception $e Propaga excecao.
     *
     * @return void
     *
     * @author thalesvalias - 01/12/11 - Implementacao dos parametros de ferias.
     */
    private function _carregaParametroFerias() {

        try{
            $this->_paramCalculo->carregaParametroFerias();

            $paramFerias = $this->_paramCalculo->getParamFerias();

            if (is_object($paramFerias) === true) {
                $this->_vrPercentAdiant13Sal = $paramFerias->getPercentualAdiantamento13Salario();
                $this->_nrDiasFeriasProvisao = $paramFerias->getNrDiasFeriasProvisao();
            } else {
                //@todo MsgCalculo
                MsgCalculo::getInstance()->adicionaMensagem('Não encontrado Parametro de Férias parametrizado no Parametro da Estrutura.');
                //tk_warning('Nao encontrado Parametro de Ferias parametrizado no Parametro da Estrutura.');
            }
        } catch (Exception $e){
            throw $e;
        }
    }

    private function _analisaAvisoPrevio($vinculo, $itens_calculo){
        /* Analisa 13 Salario e gera os eventos */
        $this->_verificaAvisoPrevio($vinculo, $itens_calculo);

        /* Se algum 12 avos gera a media dos eventos */
        if ($this->_nr_dias_aviso > 0) {
            /* Pega as datas do intervalo trabalhado e ajusta se for o caso
             pra carregar os eventos nos meses em que eles ocorreram */
            /* Mesmo que a admissao seja no meio do mes este mes entra pra media
            A data no Fpacalculofolha tem sempre o primeiro dia do mes */
            $this->_inicio_periodo_aviso->setDay(1);

            /* A data fim nao precisa ser ajustada porque os valores do mes sempre entram na
             * media */
            $listaNrEventos = $this->_eventomMedia->retornaListaEventoMedia();
            //tk_warning('ini '.$this->_fim_periodo_aviso->toString('dd/MM/YYYY'));
            //tk_warning('fim '.$this->_inicio_periodo_aviso->toString('dd/MM/YYYY').' '.$this->_nr_doze_avos);

            $listaEventosTotalizados = $this->_media->calculaMaiorMedia(
                $vinculo, FpatipomovimentEntity::TP_MOV_MENSAL, $listaNrEventos, $this->_inicio_periodo_aviso,
                $this->_fim_periodo_aviso, $this->_nrTipoModalidadeCalc, $this->_nrOcorrenciaCalc
            );
            /*$this->_media->calcula(
                $vinculo, FpatipomovimentEntity::TP_MOV_MENSAL, $itens_calculo, $listaNrEventos, $listaNrEventos, $this->_inicio_periodo_13sal,
                $this->_fim_periodo_13sal, $this->_nrTipoModalidadeCalc, $this->_nrOcorrenciaCalc, $this->_nr_doze_avos
            );*/

            // Gera uma lista chave/valor onde a chave sao os eventos de origem e o valor os de destino
            $listaEventosOrigemDestino = array_combine(split(',', $listaNrEventos), split(',', $listaNrEventos));

            //tk_warning($this->_inicio_periodo_aviso.''.$this->_fim_periodo_aviso);
            //BORBA 30/10/2013
            $this->_divisor_aviso =  $this->_calculaDivisorMedias($this->_inicio_periodo_aviso,$this->_fim_periodo_aviso);
            //tk_warning('Aviso  '.$this->_divisor_aviso);

            //BORBA 30/10/2013 - Trocado de (null) para o _divisor_ferias para adequar ao levantamento da ana paula
            $this->_media->geraEventoMedia(
                $itens_calculo, $listaEventosTotalizados, $listaEventosOrigemDestino, FpatipomovimentEntity::TP_MOV_AVISO_PREVIO_RESC,
                true,$this->_divisor_aviso  /* $this->_nr_doze_avos */
            );
        }
    }
    /**
     * Enter description here ...
     *
     * @param string                $vinculo       Vínculo.
     * @param FpaitecalcfolhaEntity $itens_calculo Itens do Calculo.
     *
     * @return void
     *
     * @author Bruno Borba
     *
     */
    private function _analisaPLR($vinculo, \FpaitecalcfolhaEntity $itens_calculo){
        /* Analisa PLR Salario e gera os eventos */
        $this->_verificaPLR($vinculo, $itens_calculo);

        $evento = $this->_assoc_eventos->retornaEventoAssociado(
            FpatipoassoceveEntity::ASSOC_PLR, $this->_eventom, $this->_nrorg
        );
        $this->_itens_calculo_principal->geraEvento($evento, $this->_mes_competencia, 0, 100, 1);

    }

    /**
     * Enter description here ...
     *
     * @param string                $vinculo       Vínculo.
     * @param FpaitecalcfolhaEntity $itens_calculo Itens do Calculo.
     *
     * @return void
     *
     * @author alessandrobartels
     *         alessandrobartels 30/11/2012 - Externalizado o processo de gerar o item calculo da media. Antes era feito
     *                                        dentro do metodo calcula() da classe MediaEventosIntervalo.
     */
    private function _analisa13Sal($vinculo, \FpaitecalcfolhaEntity $itens_calculo){
        /* Analisa 13 Salario e gera os eventos */
        $this->_verificaDecimoTerceiro($vinculo, $itens_calculo);

        /* Se algum 12 avos gera a media dos eventos */
        if ($this->_nr_doze_avos > 0) {
            /* Pega as datas do intervalo trabalhado e ajusta se for o caso
             pra carregar os eventos nos meses em que eles ocorreram */
            /* Mesmo que a admissao seja no meio do mes este mes entra pra media
             A data no Fpacalculofolha tem sempre o primeiro dia do mes */
            $this->_inicio_periodo_13sal->setDay(1);
            /* A data fim nao precisa ser ajustada porque os valores do mes sempre entram na
             * media */

            /*Porém a data fim para a busca do evento 120 de adiantamento precisa ser ajustada para o mes anterior à
            competencia para que não busque o evento no mesmo mês*/
            $fimperiodo13saladiant= clone($this->_mes_competencia);
            $fimperiodo13saladiant->addDay(-1);

            //BORBA 16/01/2013
            $eventoAdiantamento = $this->_assoc_eventos->retornaEventoAssociado(
                FpatipoassoceveEntity::ASSOC_ADIANT_13SAL, $this->_eventom, $this->_nrorg
            );
            //BORBA 16/01/2013 ainda utilizando FpatipomovimentEntity::TP_MOV_13SAL, futuramente será utilizado o FpatipomovimentEntity::TP_MOV_MENSAL
            $listaEventosTotalizados = $this->_media->calcula(
                $vinculo, FpatipomovimentEntity::TP_MOV_13SAL, $eventoAdiantamento->getNreventom(), $this->_inicio_periodo_13sal,
                $fimperiodo13saladiant, $this->_nrTipoModalidadeCalc, $this->_nrOcorrenciaCalc
            );
            $eventoAdiantamentoDb=$this->_assoc_eventos->retornaEventoAssociado(
                FpatipoassoceveEntity::ASSOC_ADIANT_13SAL_DB, $this->_eventom, $this->_nrorg
            );

            $listaEventosOrigemDestino = array_combine(array($eventoAdiantamento->getNreventom()),array($eventoAdiantamentoDb->getNreventom()));

            $this->_media->geraEventoMedia(
                $itens_calculo, $listaEventosTotalizados, $listaEventosOrigemDestino, FpatipomovimentEntity::TP_MOV_13SAL,
                False, 1
            );

            $listaNrEventos = $this->_eventomMedia->retornaListaEventoMedia();

            $listaEventosTotalizados = $this->_media->calculaMaiorMedia(
                $vinculo, FpatipomovimentEntity::TP_MOV_MENSAL, $listaNrEventos, $this->_inicio_periodo_13sal,
                $this->_fim_periodo_13sal, $this->_nrTipoModalidadeCalc, $this->_nrOcorrenciaCalc
            );

            // Gera uma lista chave/valor onde a chave sao os eventos de origem e o valor os de destino
            $listaEventosOrigemDestino = array_combine(split(',', $listaNrEventos), split(',', $listaNrEventos));

            //BORBA 23/05/2013 - Trocado o ultimo argumento de %this->_nr_doze_avos para null a pedido da Eliane
            //BORBA 31/05/2013 - Rervertido o ultimo argumento de null para %this->_nr_doze_avos a pedido do Rigel
            //BORBA 30/10/2013 - Trocado de ($this->_nr_doze_avos + $this->_nr_compl_doze_avos) para o _divisor_13 para adequar ao levantamento da ana paula
            $this->_media->geraEventoMedia(
                $itens_calculo, $listaEventosTotalizados, $listaEventosOrigemDestino, FpatipomovimentEntity::TP_MOV_13SAL,
                true, $this->_divisor_13
            );
        }
    }


    /**
     * Enter description here ...
     *
     * @param GpevinculomEntity $vinculo Instancia de GpevinculomEntity.
     *
     * @return void
     *
     * @author alessandrobartels
     *         alessandrobartels 30/11/2012 - Externalizado o processo de gerar o item calculo da media. Antes era feito
     *                                        dentro do metodo calcula() da classe MediaEventosIntervalo
     */
    private function _analisaFerias(GpevinculomEntity $vinculo){

        /* Analisa ferias e gera os eventos de ferias */
        $this->_verificaFerias($vinculo);
        /* Se algum periodo foi preparado gera a media dos eventos */
        $nr_ferias_preparado = $this->_gozo_ferias->getNrFeriasPreparado();

        if ($nr_ferias_preparado !== null) {
            /** @var $ferias FpaferiasEntity */
            $ferias = $this->_ferias->procuraFerias($nr_ferias_preparado);

            //BORBA/JORGE 15/11/2013
            /** @var $gozo FpagozoferiasEntity */
            $this->verificaGozoValidoECorrige($vinculo, $ferias);

            /* Pega as datas originais do periodo aquisitivo e ajusta se for o caso
             pra carregar os eventos nos meses em que eles ocorreram */
            $inicio_periodo_aquisitivo = new TkDateTime($ferias->getDtiniaquisicao(), TkDateTime::FORMAT_DATE);
            $inicio_periodo_aquisitivo_aux = new TkDateTime($inicio_periodo_aquisitivo, TkDateTime::FORMAT_DATE);
            if (($inicio_periodo_aquisitivo_aux->setDay(1)->equals($inicio_periodo_aquisitivo)) === false) {
                /* Mesmo que a admissao ou inicio de ferias seja no meio do mes este mes entra pra
                 * media
                 * A data no Fpacalculofolha tem sempre o primeiro dia do mes*/
                $inicio_periodo_aquisitivo->setDay(1);
            }

            $fim_periodo_aquisitivo = new TkDateTime($ferias->getDtfimaquisicao(), TkDateTime::FORMAT_DATE);
            $fim_periodo_aquisitivo_aux = new TkDateTime($fim_periodo_aquisitivo, TkDateTime::FORMAT_DATE);
            $fim_periodo_aquisitivo_aux->setDay(1)->addMonth(1)->subDay(1);
            if (($fim_periodo_aquisitivo_aux->equals($fim_periodo_aquisitivo)) === false) {
                /* Fim de aquisicao no ultimo dia do mes indica a admissao no primeiro dia do mes,
                 neste caso o mes do fim entra para a media
                 Fim de aquisicao no meio do mes faz com que este mes do fim seja considerado
                 no proximo periodo aquisitivo. Ajusta o fim pro mes anterior */
                $fim_periodo_aquisitivo->setDay(1)->subDay(1);
            }

            $listaNrEventos = $this->_eventomMedia->retornaListaEventoMedia();

            $listaEventosTotalizados = $this->_media->calculaMaiorMedia(
                $vinculo, FpatipomovimentEntity::TP_MOV_MENSAL, $listaNrEventos, $inicio_periodo_aquisitivo,
                $fim_periodo_aquisitivo, $this->_nrTipoModalidadeCalc, $this->_nrOcorrenciaCalc
            );
            /*$this->_media->calcula(
                $vinculo, FpatipomovimentEntity::TP_MOV_MENSAL, $this->_itens_calculo_principal, $listaNrEventos,
                $listaNrEventos, $inicio_periodo_aquisitivo, $fim_periodo_aquisitivo, $this->_nrTipoModalidadeCalc,
                $this->_nrOcorrenciaCalc, null
            );*/

            // Gera uma lista chave/valor onde a chave sao os eventos de origem e o valor os de destino
            $listaEventosOrigemDestino = array_combine(split(',', $listaNrEventos), split(',', $listaNrEventos));

            $this->_media->geraEventoMedia(
                $this->_itens_calculo_principal, $listaEventosTotalizados, $listaEventosOrigemDestino,
                FpatipomovimentEntity::TP_MOV_FERIAS, true, null
            );

        } else {
            //@todo MsgCalculo
            MsgCalculo::getInstance()->adicionaMensagem('Vínculo não possui gozo de férias nesta competencia.');
            //tk_warning('Vinculo '.$vinculo->getNrvinculom().' nao possui gozo de ferias nesta competencia.');
        }
    }

     /**
     * @param $vinculo GpevinculomEntity
     * @param $ferias FpaferiasEntity
     */
    private function verificaGozoValidoECorrige($vinculo, $ferias)
    {
        $diasFaltas = $ferias->_totalizaDiasFaltas(
            $vinculo, $this->_eventom, $this->_faltas_intervalo, $ferias->getDtiniaquisicao(),
            $ferias->getDtfimaquisicao(), $this->_jornada_diaria, $this->_nrTipoModalidadeCalc,
            $this->_nrOcorrenciaCalc
        );
        $faltaFerias = new \FpafaltaferiasEntity();
        $faltaFerias = $faltaFerias->verificaFaltaFerias($ferias->getNrtipoferias(), $diasFaltas);

        $dias = 0;
        /** @var $itemGozo FpagozoferiasEntity */
        foreach ($ferias->getGozoFerias() as $itemGozo) {
            $this->_gozo_ferias->addItem($itemGozo, $itemGozo->getNrgozoferias());
            $dias += $itemGozo->getDiasDataInicioAteDataFim();
        }

        if ($dias > $faltaFerias->getQtdiasmaxfe()) {
            $dtInicio = new \TkDateTime($itemGozo->getDtinigozoferias(), \TkDateTime::FORMAT_DATE);
            $dtInicio->addDay($faltaFerias->getQtdiasmaxfe())->subDay(1);
            $itemGozo->setDtfimgozoferias($dtInicio->get('dd/MM/yyyy'));
            $dtFimGozo = new \TkDateTime($itemGozo->getDtfimgozoferias());
            $itemGozo->setDtretornoferias($dtFimGozo->addDay(1)->get('dd/MM/yyyy'));
            $itemGozo->setQtdiasabonoferi(0);
            $itemGozo->persist();
            //@todo MsgCalculo
            MsgCalculo::getInstance()->adicionaMensagem('Data de gozo inválida, e corrigida para o vínculo');
            //tk_warning('Data de gozo inválida, e corrigida para o Vinculo: '.$this->_vinculom);
        }
    }



    /**
     * Enter description here ...
     *
     * @param string $vinculo     V�nculo.
     * @param string $tp_calc_mov Tipo C�lculo Movimento.
     *
     * @return void
     *
     * @author alessandrobartels
     *         alessandrobartels 30/11/2012 - Calculo de meida - Externalizado o processo de gerar o item calculo da media.
     *                                        Antes era feito dentro do metodo calcula() da classe MediaEventosIntervalo
     */
    private function _analisaFeriasRescisaoProvisao($vinculo, $tp_calc_mov){

        if ($this->_nr_tipo_calculo === FpatipocalculoEntity::CALC_PROVISAO_CONTABIL) {
            $dt_rescisao_projetada = $this->_ultimo_dia_mes;
        } else {
            // @todo Fazer tratamento da data projetado para rescisao.
            $dt_rescisao_projetada = $vinculo->getDtrescisaovinc();
        }
        $dataRescisaoProjetado = new TkDateTime($dt_rescisao_projetada);
        //BORBA 29/11/2013 Parametros alterados
        $ferias = $this->_ferias->verificaFeriasRescisao($vinculo, $dataRescisaoProjetado, true, $this->_eventom,
            $this->_faltas_intervalo,$this->_jornada_diaria, $this->_nrTipoModalidadeCalc, $this->_nrOcorrenciaCalc,
            $this->_alteracao_situacao_funcional,$this->_mes_competencia);
        if(($this->_nr_dias_aviso+$this->_nr_compl_dias_aviso)>0){
            /*Chama novamente a verificação de férias projetando a data com as indenizações false*/
            $dt_rescaux= new TkDateTime($dt_rescisao_projetada);
            $dt_rescaux->addDay($this->_nr_compl_dias_aviso + $this->_nr_dias_aviso);
            //BORBA 29/11/2013 Argumentos alterados
            $ferias_projetado = $this->_ferias->verificaFeriasRescisao($vinculo, $dt_rescaux, false, $this->_eventom,
                $this->_faltas_intervalo,$this->_jornada_diaria, $this->_nrTipoModalidadeCalc, $this->_nrOcorrenciaCalc,
                $this->_alteracao_situacao_funcional,$this->_mes_competencia);
        }
        $contador_ferias_vencidas = 0;

        for ($i=0; $i < count($ferias); $i++) {

            $dtInicioAquisicao = new TkDateTime($ferias[$i]['DTINIAQUISICAO']);
            $dtFimAquisicao = new TkDateTime($ferias[$i]['DTFIMAQUISICAO']);
            //BORBA 29/11/2013 Proporcionaliza dias de direito para ser aplicado em férias em aberto
            $proporcaoPerda=1/30*$ferias[$i]['QTDIASMAXFE'];
            switch ($ferias[$i]['IDCONTROLFERIAS']){
                case FpaferiasEntity::IDCONTROLFERIAS_ABERTO:

                    /*BORBA 12/12/2014 Criado para transportar o avo integral para o cálculo Atendendo à solicitação 153857*/
                    $evento = $this->_assoc_eventos->retornaEventoAssociado(
                        FpatipoassoceveEntity::ASSOC_AUX_AVO_INTEGRAL, $this->_eventom, $this->_nrorg
                    );
                    $this->_itens_ferias_proporcionais->geraEvento(
                        $evento, $dtInicioAquisicao, 0, $ferias[$i]['QTMESESMAXFE'], 1
                    );

                    $evento = $this->_assoc_eventos->retornaEventoAssociado(
                        FpatipoassoceveEntity::ASSOC_FERIAS_PROPORC, $this->_eventom, $this->_nrorg
                    );
                    $this->_itens_ferias_proporcionais->geraEvento(
                        $evento, $dtInicioAquisicao, 0, $ferias[$i]['QTMESESMAXFE']*$proporcaoPerda, 1
                    );
                    $evento = $this->_assoc_eventos->retornaEventoAssociado(
                        FpatipoassoceveEntity::ASSOC_ADIC_FERI_PROP, $this->_eventom, $this->_nrorg
                    );
                    $this->_itens_ferias_proporcionais->geraEvento(
                        $evento, $dtInicioAquisicao, 0, $ferias[$i]['QTMESESMAXFE']*$proporcaoPerda, 1
                    );
                    if(($this->_nr_dias_aviso+$this->_nr_compl_dias_aviso)>0){

                        /*BORBA 12/12/2014 Criado para transportar o avo integral para o cálculo Atendendo à solicitação 153857*/
                        $evento = $this->_assoc_eventos->retornaEventoAssociado(
                            FpatipoassoceveEntity::ASSOC_AUX_AVO_INTEGRAL_COMPL, $this->_eventom, $this->_nrorg
                        );
                        $this->_itens_ferias_proporcionais->geraEvento(
                            $evento, $dtInicioAquisicao, 0, ($ferias_projetado[$i]['QTMESESMAXFE'] - $ferias[$i]['QTMESESMAXFE']), 1
                        );
                        $evento = $this->_assoc_eventos->retornaEventoAssociado(
                            FpatipoassoceveEntity::ASSOC_FERIAS_PROPORC_COMPL, $this->_eventom, $this->_nrorg
                        );
                        $this->_itens_ferias_proporcionais->geraEvento(
                            $evento, $dtInicioAquisicao, 0, ($ferias_projetado[$i]['QTMESESMAXFE'] - $ferias[$i]['QTMESESMAXFE'])*$proporcaoPerda, 1
                        );
                        $evento = $this->_assoc_eventos->retornaEventoAssociado(
                            FpatipoassoceveEntity::ASSOC_ADIC_FERI_PROP_COMPL, $this->_eventom, $this->_nrorg
                        );
                        $this->_itens_ferias_proporcionais->geraEvento(
                            $evento, $dtInicioAquisicao, 0, ($ferias_projetado[$i]['QTMESESMAXFE'] - $ferias[$i]['QTMESESMAXFE'])*$proporcaoPerda, 1
                        );
                    }
                    $listaNrEventos = $this->_eventomMedia->retornaListaEventoMedia();
                    //BORBA 12/11/2013
                    $dtInicioAquisicao->setDay(1);
                    //tk_warning('ferias');
                    //tk_warning('ini Fer '.$dtInicioAquisicao->toString('dd/MM/YYYY'));
                    //tk_warning('fim Fer '.$dtFimAquisicao->toString('dd/MM/YYYY'));
                    $listaEventosTotalizados = $this->_media->calculaMaiorMedia(
                        $vinculo, FpatipomovimentEntity::TP_MOV_MENSAL, $listaNrEventos, $dtInicioAquisicao, $dtFimAquisicao,
                        $this->_nrTipoModalidadeCalc, $this->_nrOcorrenciaCalc
                    );
                    //tk_var_dump($listaEventosTotalizados);

                    // Gera uma lista chave/valor onde a chave sao os eventos de origem e o valor os de destino
                    $listaEventosOrigemDestino = array_combine(split(',', $listaNrEventos), split(',', $listaNrEventos));

                    //BORBA 30/10/2013
                    $this->_divisor_ferias =  $this->_calculaDivisorMedias($dtInicioAquisicao,$dtFimAquisicao);
                    //tk_warning('Ferias na resc  '.$this->_divisor_ferias);
                    //BORBA 30/10/2013 - Trocado de ($ferias_projetado[$i]['QTMESESMAXFE']) para o _divisor_ferias para adequar ao levantamento da ana paula
                    $this->_media->geraEventoMedia(
                        $this->_itens_ferias_proporcionais, $listaEventosTotalizados, $listaEventosOrigemDestino,
                        FpatipomovimentEntity::TP_MOV_FERIAS, true, $this->_divisor_ferias
                    );

                    break;

                case FpaferiasEntity::IDCONTROLFERIAS_ADQUIRIDO:
                case FpaferiasEntity::IDCONTROLFERIAS_GOZADO_PARCIAL:
                    if ($contador_ferias_vencidas > count($this->_itens_ferias_vencidas)-1) {
                        /* Insere um novo numero de calculo para ferias vencidas.
                         * Neste caso ha ocorrencia de mais de uma ferias vencidas.
                         * alessandrobartels - 22/08/2011
                         */
                        $tp_calc_mov->insereNrCalculoFolha(
                            $this->_calculo_folha, $this->_nrorg, $this->_mes_competencia, $this->_ferias_vencidas,
                            $this->_nrTipoModalidadeCalc, $this->_nrOcorrenciaCalc
                        );

                        /* Retorna objeto FpaTpCalcMovLogic para pegar os itens de calculo.
                         * alessandrobartels - 22/08/2011
                         */
                        $obj = end($tp_calc_mov->retornaPosicaoTpMov($this->_ferias_vencidas));

                        /* Armazena as instancias de itens de calculo em um array.
                         * alessandrobartels - 22/08/2011
                         */
                        $this->_itens_ferias_vencidas[] =  $obj->getInstancia();
                    }

                    $evento = $this->_assoc_eventos->retornaEventoAssociado(
                        FpatipoassoceveEntity::ASSOC_FERIAS_VENC_RESC, $this->_eventom, $this->_nrorg
                    );

                    /* $this->_itens_ferias_vencidas[$contador_ferias_vencidas]->geraEvento(
                     * $evento,$this->_mes_competencia,0,$ferias[$i]['QTDIASMAXFE'],1); */

                    $this->_itens_ferias_vencidas[$contador_ferias_vencidas]->geraEvento(
                        $evento, $dtInicioAquisicao, 0, $ferias[$i]['QTDIASMAXFE'], 1
                    );

                    $evento = $this->_assoc_eventos->retornaEventoAssociado(
                        FpatipoassoceveEntity::ASSOC_ADIC_FER_VENC_RES, $this->_eventom, $this->_nrorg
                    );

                    /* $this->_itens_ferias_vencidas[$contador_ferias_vencidas]->geraEvento(
                     * $evento,$this->_mes_competencia,0,$ferias[$i]['QTDIASMAXFE'],1); */

                    $this->_itens_ferias_vencidas[$contador_ferias_vencidas]->geraEvento(
                        $evento, $dtInicioAquisicao, 0, $ferias[$i]['QTDIASMAXFE'], 1
                    );

                    $listaNrEventos = $this->_eventomMedia->retornaListaEventoMedia();
                    //Correção período BORBA 28/08/2014
                    $dtInicioAquisicao->setDay(1);
                    $dtFimAquisicao->setDay(1)->addDay(-1);
                    $listaEventosTotalizados = $this->_media->calculaMaiorMedia(
                        $vinculo, FpatipomovimentEntity::TP_MOV_MENSAL, $listaNrEventos, $dtInicioAquisicao, $dtFimAquisicao,
                        $this->_nrTipoModalidadeCalc, $this->_nrOcorrenciaCalc
                    );
                    /*$this->_media->calcula(
                        $vinculo, FpatipomovimentEntity::TP_MOV_MENSAL,
                        $this->_itens_ferias_vencidas[$contador_ferias_vencidas], $listaNrEventos, $listaNrEventos,
                        $dtInicioAquisicao, $dtFimAquisicao, $this->_nrTipoModalidadeCalc, $this->_nrOcorrenciaCalc, null
                    );*/

                    // Gera uma lista chave/valor onde a chave sao os eventos de origem e o valor os de destino
                    $listaEventosOrigemDestino = array_combine(split(',', $listaNrEventos), split(',', $listaNrEventos));
                    //BORBA 30/10/2013
                    $this->_divisor_ferias =  $this->_calculaDivisorMedias($dtInicioAquisicao,$dtFimAquisicao);
                    //tk_warning('Ferias na resc  '.$this->_divisor_ferias);
                    //BORBA 30/10/2013 - Trocado de (null) para o _divisor_ferias para adequar ao levantamento da ana paula
                    $this->_media->geraEventoMedia(
                        $this->_itens_ferias_vencidas[$contador_ferias_vencidas], $listaEventosTotalizados,
                        $listaEventosOrigemDestino, FpatipomovimentEntity::TP_MOV_FERIAS, true,$this->_divisor_ferias
                    );

                    $contador_ferias_vencidas++;
                    break;
            }

            unset($dtInicioAquisicao);
            unset($dtFimAquisicao);
        }
    }

    /**
     * Enter description here ...
     *
     * @param GpevinculomEntity $vinculo Instancia de GpevinculomEntity.
     * @param FpaitecalcfolhaEntity $itens_calculo Instancia de FpaitecalcfolhaEntity
     * @return void
     *
     * @author brunoborba
     */
    private function _analisaFimContrato(GpevinculomEntity $vinculo, FpaitecalcfolhaEntity $itens_calculo){
        $auxGeraEvento=false;

        $diasExp1 = $vinculo->getNrdiascontratoexp() ? $vinculo->getNrdiascontratoexp()-1 : 0;
        $diasExp2 = $vinculo->getNrdiascontratoexppro() ? $vinculo->getNrdiascontratoexppro() : 0;

        $this->_dt_fim_exp1 = new TkDateTime($vinculo->getDtadmissaovinc());
        $this->_dt_fim_exp1->addDay($diasExp1);

        $this->_dt_fim_exp2 = new TkDateTime($vinculo->getDtadmissaovinc());
        $this->_dt_fim_exp2->addDay($diasExp1+$diasExp2);

        if($this->_nr_tipo_calculo==FpaTipocalculoEntity::CALC_PROVISAO_CONTABIL){//Provisão
            $dtRescisao = new TkDateTime(FPA::getUltimoDiaMes());
        }
        else{
            $dtRescisao = new TkDateTime($vinculo->getDtrescisaovinc());
        }

        //*todo Verificar necessidade de usar $diasInden como atributo de classe*/
        if($vinculo->getNrdiascontratoexp()!=null && $dtRescisao->isEarlier($this->_dt_fim_exp1)){
            $diasInden = ($dtRescisao->daysAfter($this->_dt_fim_exp1)-1)/2;
            $auxGeraEvento=true;
            //tk_warning('dentro do primeiro contrato '.$diasInden);
        }elseif($vinculo->getNrdiascontratoexppro()!=null && $dtRescisao->isEarlier($this->_dt_fim_exp2)){
            $diasInden = ($dtRescisao->daysAfter($this->_dt_fim_exp2)-1)/2;
            $auxGeraEvento=true;
            //tk_warning('dentro do segundo contrato '.$diasInden);
        }elseif($vinculo->historico->getDtfimcontrdetermin()!= null && $dtRescisao->isEarlier($vinculo->historico->getDtfimcontrdetermin())){
            $diasInden = ($dtRescisao->daysAfter($vinculo->historico->getDtfimcontrdetermin())-1)/2;
            $auxGeraEvento=true;
            //tk_warning('dentro do contrato com prazo determinado '.$diasInden);
        }else{

            //BORBA 27/09/2013 - Colocado junto ao analisaAvisoPrevio, pois em qualquer um dos casos um ou outro somente serão preparados
            //após a verificação do termino de contrato de experiencia ou determinado
            /*Gera Evento ASSOC_AVISO_PREVIO_DESC com pedido de demissão do funcionário*/
            if ($vinculo->getNrtpdemissao()==FpaTpdemissaoEntity::SEM_JUSTA_CAUSA_EMPREGADO){
                if($vinculo->getDtrescisaovinc()===$vinculo->getDtavisoprevio()) {
                    $evento = $this->_assoc_eventos->retornaEventoAssociado(
                        FpatipoassoceveEntity::ASSOC_AVISO_PREVIO_DESC, $this->_eventom, $this->_nrorg
                    );
                    $itens_calculo->geraEvento($evento, null, 0, 30, 1);
                }
            }else{
                //BORBA 14/08/2013 retirado do _executaPreparacaoEspecifica temporáriamente
                $this->_analisaAvisoPrevio($vinculo, $this->_itens_aviso_previo);
            }
        }
        //*todo Não usar o teste de tipo de demissão e sim a lista de direitos, a lista de direitos não é setada na preparação*/

        if ($vinculo->getNrtpdemissao()==FpaTpdemissaoEntity::ANTECIPACAO_EMPREGADO && $auxGeraEvento==true){
            /*Gera Evento ASSOC_INDENIZ_ART_480 com quebra do contrato de experiencia(DESCONTO)*/
            $evento = $this->_assoc_eventos->retornaEventoAssociado(
                FpatipoassoceveEntity::ASSOC_INDENIZ_ART_480, $this->_eventom, $this->_nrorg
            );
            $itens_calculo->geraEvento($evento, null, 0,  $diasInden, 1);
        }
        if ($vinculo->getNrtpdemissao()==FpaTpdemissaoEntity::ANTECIPACAO_EMPREGADOR && $auxGeraEvento==true){
            /*Gera Evento ASSOC_INDENIZ_ART_479 com quebra do contrato de experiencia(PROVENTO)*/
            $evento = $this->_assoc_eventos->retornaEventoAssociado(
                FpatipoassoceveEntity::ASSOC_INDENIZ_ART_479, $this->_eventom, $this->_nrorg
            );
            $itens_calculo->geraEvento($evento, null, 0,  $diasInden, 1);
        }


    }

    /**
     * Enter description here ...
     *
     * @param string $dt_inicio Data Inicio.
     * @param string $dt_fim    Data Fim.
     *
     * @return number
     */
    private function _quantidadeDiasAfastados($dt_inicio, $dt_fim){

        /* @todo verificar com Rigel os parametros */
        $afastamento = $this->_alteracao_situacao_funcional->retornaDiasAfastamento(
            $this->_situacao_funcional, $dt_inicio, $dt_fim, false
        );

        $dias_afastados = 0;
        for ($i=0; $i < count($afastamento); $i++) {
            $sit_func = $this->_situacao_funcional->retornaSituacaoFuncional(
                $this->_nrOrgPadrao, $this->_nrorg, $afastamento[$i]
            );

            if ($sit_func == true) {
                if ($sit_func->historico->getIdsusp13sal() === GpesitufunchEntity::IDSUSP13SAL_SIM) {
                    $dias_afastados++;
                }
            }
        }

        return $dias_afastados;
    }


    /**
     * Retorna a quantidade de faltas por período - em FpaferiasEntity tem algo similar porém não tão genérico
     *
     * @param GpevinculomEntity $vinculo
     * @param string $dt_inicio
     * @param string $dt_fim
     *
     * @return float
     *
     * @author Bruno Borba 03/13/2013
     */
    private function _quantidadeFaltas(\GpevinculomEntity $vinculo, $dt_inicio, $dt_fim){

        /* @todo verificar com Rigel os parametros */
        $lista_eventos = $this->_faltas_intervalo->calcula(
            $vinculo, $dt_inicio, $dt_fim, $this->_nrTipoModalidadeCalc, $this->_nrOcorrenciaCalc, $this->_nrOrgPadrao
        );

        $total_dias = 0;

        foreach ($lista_eventos as $nr_evento=> $item_evento) {
            $evento = $this->_eventom->retornaEvento($nr_evento);
            $tipo_referencia = $evento->historico->getIdunidrefereven();
            $id_faltas_ferias = $evento->historico->getIdfaltasferias();

            /* @todo mudar constante */
            $total_aux = number_format(
                FpaeventohEntity::compatibilizaReferenciaDias($item_evento['REF'], $tipo_referencia, $this->_jornada_diaria), 2
            );

            switch ($id_faltas_ferias){
                case FpaeventohEntity::IDFALTASFERIAS_SOMA:		$total_dias += $total_aux; break;
                case FpaeventohEntity::IDFALTASFERIAS_SUBTRAI: 	$total_dias -= $total_aux; break;
            }
        }

        // Retorna dias de faltas / atraso.  Arredonda para baixo.
        return  floor($total_dias);

    }

    /**
     * Enter description here ...
     *
     * @param string $dt_inicio Data In�cio.
     * @param string $dt_fim    Data Fim.
     *
     * @return number
     */
    private function _calculaNrDozeAvosDecimoTerceiro($vinculo, $dt_inicio, $dt_fim, $qtMinimoDias=15){

        $mes_ini = $dt_inicio->toValue(TkDateTime::MONTH);
        $mes_fim = $dt_fim->toValue(TkDateTime::MONTH);

        $nr_doze_avos = 0;
        $dt_aux_inicio = new TkDateTime();
        $dt_aux_fim = new TkDateTime();

        // BORBA 25/11/2013 Em caso de virada de ano o não entra no for, forçando pra 13 o for itera a quantidade de vezes necessárias
        //testar posteriormente com dias de complemento acima de 30
        // Feito sem pensar muito e na correria das prioridades SHIFTANTES, aceito sugestões de lógicas melhores. =))
        $ano_ini=$dt_inicio->toValue(TkDateTime::YEAR);
        $ano_fim=$dt_fim->toValue(TkDateTime::YEAR);
        if($ano_fim>$ano_ini){
            $mes_fim=13;
        }

        for ($i = $mes_ini; $i<=($mes_fim); $i++) {
            /* primeiro mes */
            if ($i === $mes_ini) {
                $dt_aux_inicio->set($dt_inicio, TkDateTime::FORMAT_DATE);
                $dt_aux_fim->set($dt_inicio, TkDateTime::FORMAT_DATE);
                $dt_aux_fim->setDay(1)->addMonth(1)->subDay(1);
                if($dt_aux_fim->isLater($dt_fim)){                            //Borba 23/02/2013
                    $dt_aux_fim->set($dt_fim, TkDateTime::FORMAT_DATE);      //Borba 23/02/2013
                }

                /* ultimo mes */
            } elseif ($i === $mes_fim) {
                $dt_aux_inicio->set($dt_fim, TkDateTime::FORMAT_DATE);
                $dt_aux_inicio->setDay(1);
                $dt_aux_fim->set($dt_fim, TkDateTime::FORMAT_DATE);

                /* meses intermediarios */
            } else {
                $dt_aux_inicio->set($dt_inicio, TkDateTime::FORMAT_DATE);
                $dt_aux_inicio->setDay(1)->setMonth($i);
                $dt_aux_fim->set($dt_aux_inicio, TkDateTime::FORMAT_DATE);
                $dt_aux_fim->setDay(1)->addMonth(1)->subDay(1);
            }
            $dias_intervalo = $dt_aux_inicio->daysAfter($dt_aux_fim);
            if ($dias_intervalo >= $qtMinimoDias) {
                $dias_afastados = $this->_quantidadeDiasAfastados($dt_aux_inicio, $dt_aux_fim);
                $dias_faltas=$this->_quantidadeFaltas($vinculo, $dt_aux_inicio, $dt_aux_fim);

                if (($dias_intervalo - $dias_afastados - $dias_faltas) >= $qtMinimoDias) {
                    $nr_doze_avos++;
                }
            }
        }

        return $nr_doze_avos;

    }

    /**
     * Calcula o dividor para médias em geral
     *
     * @param string $dt_inicio Data In�cio.
     * @param string $dt_fim    Data Fim.
     *
     * @return number
     */
    private function _calculaDivisorMedias($dt_inicio,$dt_fim){

        // $dt_ini = $dt_inicio->toValue(TkDateTime::MONTH);
        //$dt_fim = $dt_fim->toValue(TkDateTime::MONTH);

        $data1 = $dt_inicio;
        $arr = explode('/',$data1);

        $data2 = $dt_fim;
        $arr2 = explode('/',$data2);

        // $dia1 = $arr[0];
        $mes1 = $arr[1];
        $ano1 = $arr[2];

        // $dia2 = $arr2[0];
        $mes2 = $arr2[1];
        $ano2 = $arr2[2];

        $a1 = ($ano2 - $ano1)*12;
        $m1 = ($mes2 - $mes1)+1;
        $divisor = ($m1 + $a1);

        if ($divisor>12){
            $divisor=12;
        }

        return $divisor;

    }

    // Borba 20/02/2013
    private function _atribuiInicioPeriodoAvisoPrevio(TkDateTime $dtAdmissao){
        if ($dtAdmissao->isLater($this->_12_meses_atras) === true) {
            $this->_inicio_periodo_aviso = $dtAdmissao;
        } else {
            $this->_inicio_periodo_aviso = $this->_12_meses_atras;
        }
    }
    /**
     * Atribui valores para o inicio do periodo de 13 Salario.
     *
     * @param TkDateTime $dtAdmissao Data de admissao do vinculo.
     *
     * @return void
     *
     * @author alessandrobartels 05/08/2011
     */
    private function _atribuiInicioPeriodo13Salario(TkDateTime $dtAdmissao){
        if ($dtAdmissao->isLater($this->_primeiro_dia_ano) === true) {
            $this->_inicio_periodo_13sal = $dtAdmissao;
        } else {
            $this->_inicio_periodo_13sal = $this->_primeiro_dia_ano;
        }
    }
    // Borba 20/02/2013

    private function _atribuiFimPeriodoAvisoPrevio(TkDateTime $dtRescisao){
        if ($dtRescisao !== null) {
            if ($dtRescisao->isEarlier($this->_ultimo_dia_ano) === true) {
                $this->_fim_periodo_aviso = $dtRescisao;
            } else {
                $this->_fim_periodo_aviso = $this->_ultimo_dia_ano;
            }
        } else {
            $this->_fim_periodo_aviso = $this->_ultimo_dia_ano;
        }
    }

    /**
     * Atribui valores para o fim do periodo de 13 Salario.
     *
     * @param TkDateTime $dtRescisao Data de rescisao do vinculo.
     *
     * @return void
     *
     * @author alessandrobartels 05/08/2011
     */
    private function _atribuiFimPeriodo13Salario(TkDateTime $dtRescisao){
        if ($dtRescisao !== null) {
            if ($dtRescisao->isEarlier($this->_ultimo_dia_ano) === true) {
                $this->_fim_periodo_13sal = $dtRescisao;
            } else {
                $this->_fim_periodo_13sal = $this->_ultimo_dia_ano;
            }
        } else {
            $this->_fim_periodo_13sal = $this->_ultimo_dia_ano;
        }
    }
    // Borba 20/02/2013
    private function _verificaAvisoPrevio(GpevinculomEntity $vinculo, FpaitecalcfolhaEntity $itens_calculo){
        $dt_admissao = new TkDateTime($vinculo->getDtadmissaovinc(), TkDateTime::FORMAT_DATE);

        $dt_rescisao = $vinculo->getDtrescisaovinc();
        if (empty($dt_rescisao) === false) {
            $dt_rescisao = new TkDateTime($vinculo->getDtrescisaovinc(), TkDateTime::FORMAT_DATE);
        } else {
            $dt_rescisao = null;
        }

        $this->_atribuiInicioPeriodoAvisoPrevio($dt_admissao);

        $this->_verificaAvisoPrevioCalculoProvisao($dt_rescisao);

        $this->_nr_dias_aviso = 30;

        $dtadmaux = new TkDateTime($vinculo->getDtadmissaovinc());
        //Testa a data de rescisão antes de passa-la ao construtor de classe do tkdatetime, caso seja nula passa a
        //data do mes de competencia  BORBA 13/03/2013
        if ($vinculo->getDtrescisaovinc() != null){
            $dtrescaux = new TkDateTime($vinculo->getDtrescisaovinc());
        }else {
            $dtrescaux = new TkDateTime($this->_mes_competencia);
        }

        // Borba 23/02/2013 projeta $dtrescaux 30 dias à frente para calculo de complemento de dias de aviso.
        $dtrescaux->addDay($this->_nr_dias_aviso);
        $intervaloanos= $dtrescaux->yearsAfter($dtadmaux);


        // Borba 23/02/2013 Limita quantidade de dias complementares em 60. ex ($intervaloanos=20) * 3 = 60
        if($intervaloanos>20){
            $intervaloanos=20;
        }
        $this->_nr_compl_dias_aviso = $intervaloanos * 3;

        // Movido para cá para evitar que o sistema faça a média sem necessidade
        // antes estava no final de tudo - borba - 14/09/2013
        // Quando a data de Aviso é igual à data de rescisão no vínculo o sistema entende que o aviso não foi cumprido e deve ser indenizado
        if($vinculo->getDtrescisaovinc()===$vinculo->getDtavisoprevio()){
            // Deixa as variaveis de instância nr_dias_aviso e o complemento setadas para serem usadas nas ferias e no décimo terceiro

        }else{
            if ($this->_nr_tipo_calculo != FpatipocalculoEntity::CALC_PROVISAO_CONTABIL) {
                // Se o aviso não é indenizado não vai acrescer nada em ferias ou decimo terceiro.
                $this->_nr_dias_aviso = 0;
                $this->_nr_compl_dias_aviso = 0;
            }
        }

        if ($this->_nr_dias_aviso > 0) {
            switch($this->_nr_tipo_calculo){

                case FpatipocalculoEntity::CALC_RESCISAO:
                case FpatipocalculoEntity::CALC_RESCISAO_COMPLEMENTAR:
                case FpatipocalculoEntity::CALC_PROVISAO_CONTABIL:
                    /*Gera Evento com dias de aviso*/
                    $evento = $this->_assoc_eventos->retornaEventoAssociado(
                        FpatipoassoceveEntity::ASSOC_AVISO_PREVIO_INDEN, $this->_eventom, $this->_nrorg
                    );
                    $itens_calculo->geraEvento($evento, null, 0, $this->_nr_dias_aviso, 1);
                    /*Gera Evento com complemento de dias de aviso*/
                    $evento = $this->_assoc_eventos->retornaEventoAssociado(
                        FpatipoassoceveEntity::ASSOC_COMPL_AV_PREV_INDZ, $this->_eventom, $this->_nrorg
                    );
                    $itens_calculo->geraEvento($evento, null, 0, $this->_nr_compl_dias_aviso, 1);
                    break;
                default:
                    //@todo MsgCalculo
                    MsgCalculo::getInstance()->adicionaMensagem('Tipo de Calculo '.$this->_nr_tipo_calculo.' nao tratado.',MsgCalculo::ERRO,true);
                    //tk_warning('Tipo de Calculo '.$this->_nr_tipo_calculo.' nao tratado <PREPARACAO.PHP>');
            }
        }
    }
    /**
     * Enter description here ...
     *
     * @param GpevinculomEntity     $vinculo       Instancia de GpevinculomEntity.
     * @param FpaitecalcfolhaEntity $itens_calculo Instancia de FpaitecalcfolhaEntity.
     *
     * @return void
     */
    private function _verificaDecimoTerceiro(GpevinculomEntity $vinculo, FpaitecalcfolhaEntity $itens_calculo){
        $dt_admissao = new TkDateTime($vinculo->getDtadmissaovinc(), TkDateTime::FORMAT_DATE);

        $dt_rescisao = $vinculo->getDtrescisaovinc();

        if (empty($dt_rescisao) === false) {
            $dt_rescisao = new TkDateTime($vinculo->getDtrescisaovinc(), TkDateTime::FORMAT_DATE);
        } else {
            $dt_rescisao = null;
        }

        $this->_atribuiInicioPeriodo13Salario($dt_admissao);

        $this->_verificaDecimoTerceiroCalculoProvisao($dt_rescisao);

        // Adiciona as alteracoes na lista.
        $this->_alteracao_situacao_funcional->retornaAlteracaoSituacaoFuncional(
            $vinculo->getNrorg(), $vinculo->getNrvinculom(), $vinculo->getDtadmissaovinc()
        );

        //BORBA 07/07/2014
        //Marcelo 14-11-2014 - Alteracao para que seja considerado como divisor sempre o mes anterior a competencia corrente			
		//Marcelo 15-12-2014 - O divisor deve considerar o período de dias trabalhados no mês conforme um parâmetro que destina-se
		//                     à informar a qtde. de dias mínimos que o funcionario deve trabalhar para que o mes entre como divisor das medias					
        $fpaparamsindicato = \Folha\Entities\FpaParamsindicato::findOneByNrestruturamAndNrorg($vinculo->historico->getNrestrutsind(),$vinculo->getNrorg());
        if(is_object($fpaparamsindicato)) {
     	    $diasminimo = $fpaparamsindicato->getNrdiv13antecip();
        } else {
		    $diasminimo = 15;
		}
		$dtfinal = new TkDateTime(\FPA::getUltimoDiaMes());
		$this->_divisor_13 = $this->_calculaNrDozeAvosDecimoTerceiro($vinculo,
            $this->_inicio_periodo_13sal, $dtfinal, $diasminimo) - 1;
		
        $this->_nr_doze_avos = $this->_calculaNrDozeAvosDecimoTerceiro($vinculo,
            $this->_inicio_periodo_13sal, $this->_fim_periodo_13sal
        );

        $dt_rescaux= new TkDateTime($this->_fim_periodo_13sal);
        $dt_rescaux->addDay($this->_nr_compl_dias_aviso + $this->_nr_dias_aviso);
        $this->_nr_compl_doze_avos = $this->_calculaNrDozeAvosDecimoTerceiro($vinculo,
            $this->_inicio_periodo_13sal, $dt_rescaux
        );

        $this->_nr_compl_doze_avos = $this->_nr_compl_doze_avos-$this->_nr_doze_avos;

        if (($this->_nr_doze_avos + $this->_nr_compl_doze_avos ) > 0) {
            switch($this->_nr_tipo_calculo){
                case FpatipocalculoEntity::CALC_13SAL:
                    $evento = $this->_assoc_eventos->retornaEventoAssociado(
                        FpatipoassoceveEntity::ASSOC_13SAL, $this->_eventom, $this->_nrorg
                    );
                    // $itens_calculo->geraEvento($evento, $this->_mes_competencia, 0, $this->_nr_doze_avos, 1);.
                    $itens_calculo->geraEvento($evento, null, 0, $this->_nr_doze_avos, 1);
                    break;
                case FpatipocalculoEntity::CALC_ADIANT_13SAL:
                    $evento = $this->_assoc_eventos->retornaEventoAssociado(
                        FpatipoassoceveEntity::ASSOC_ADIANT_13SAL, $this->_eventom, $this->_nrorg
                    );
                    // $itens_calculo->geraEvento($evento, $this->_mes_competencia, 0, $this->_percentual_adiantamento, 1);.
                    $itens_calculo->geraEvento($evento, null, 0, $this->_percentual_adiantamento, 1);
                    /* Gera evento com a quantidade de 12 avos para posterior aplicacao do percentual */
                    $evento = $this->_assoc_eventos->retornaEventoAssociado(
                        FpatipoassoceveEntity::ASSOC_13SAL_12AVOS, $this->_eventom, $this->_nrorg
                    );
                    // $itens_calculo->geraEvento($evento, $this->_mes_competencia, 0, $this->_nr_doze_avos, 1);.
                    $itens_calculo->geraEvento($evento, null, 0, $this->_nr_doze_avos, 1);
                    break;
                case FpatipocalculoEntity::CALC_RESCISAO:
                case FpatipocalculoEntity::CALC_RESCISAO_COMPLEMENTAR:
                case FpatipocalculoEntity::CALC_PROVISAO_CONTABIL:
                    $evento = $this->_assoc_eventos->retornaEventoAssociado(
                        FpatipoassoceveEntity::ASSOC_13SAL_RESC, $this->_eventom, $this->_nrorg
                    );
                    $itens_calculo->geraEvento($evento, null, 0, $this->_nr_doze_avos, 1);

                    $evento = $this->_assoc_eventos->retornaEventoAssociado(
                        FpatipoassoceveEntity::ASSOC_13SAL_COMPL_RESC, $this->_eventom, $this->_nrorg
                    );
                    $itens_calculo->geraEvento($evento, null, 0, $this->_nr_compl_doze_avos, 1);
                    break;
                default:
                    //@todo MsgCalculo
                    MsgCalculo::getInstance()->adicionaMensagem('Tipo de Calculo '.$this->_nr_tipo_calculo.' não tratado.',MsgCalculo::ERRO,true);
                    //tk_warning('Tipo de Calculo '.$this->_nr_tipo_calculo.' nao tratado <PREPARACAO.PHP>');
            }
        }
    }

    /**
     * Enter description here ...
     *
     * @param GpevinculomEntity     $vinculo       Instancia de GpevinculomEntity.
     * @param FpaitecalcfolhaEntity $itens_calculo Instancia de FpaitecalcfolhaEntity.
     *
     * @return void
     */
    private function _verificaPLR(GpevinculomEntity $vinculo, FpaitecalcfolhaEntity $itens_calculo){
        /*@todo proporcionalizar avos para quem foi admitido recentemente*/
    }
    // Borba 20/02/2013
    private function _verificaAvisoPrevioCalculoProvisao(TkDateTime $dt_rescisao) {
        if ($this->_nr_tipo_calculo === FpatipocalculoEntity::CALC_PROVISAO_CONTABIL) {
            $this->_fim_periodo_aviso = $this->_ultimo_dia_mes;
        } else {
            $this->_atribuiFimPeriodoAvisoPrevio($dt_rescisao);
        }
    }


    /**
     * Gera periodo final de 13� para calculo de provisao contabil.
     *
     * @param TkDateTime $dt_rescisao Data de rescisao.
     *
     * @return void
     *
     * @author alessandrobartels 27/07/2011
     */
    private function _verificaDecimoTerceiroCalculoProvisao(TkDateTime $dt_rescisao) {
        if ($this->_nr_tipo_calculo === FpatipocalculoEntity::CALC_PROVISAO_CONTABIL) {
            $this->_fim_periodo_13sal = $this->_ultimo_dia_mes;
        } else {
            $this->_atribuiFimPeriodo13Salario($dt_rescisao);
            /*
            if ($dt_rescisao !== null) {
                if ($dt_rescisao->isEarlier($this->_ultimo_dia_ano) === true) {
                    $this->_fim_periodo_13sal = $dt_rescisao;
                } else {
                    $this->_fim_periodo_13sal = $this->_ultimo_dia_ano;
                }
            } else {
                $this->_fim_periodo_13sal = $this->_ultimo_dia_ano;
            }
            */
        }
    }


    /**
     * Enter description here ...
     *
     * @param GpevinculomEntity $vinculo Instancia de GpevinculoEntity.
     *
     * @return \FpaferiasEntity
     *
     * @author alessandrobartels
     * 		   thalesvalias - 01/12/11 - Implementada condicao de dias de ferias para a provisao e o percentual
     * 									 do adiantamento de 13 salario em ferias.
     */
    private function _verificaFerias(GpevinculomEntity $vinculo){
        $this->_ferias->retornaFerias($vinculo->getNrorg(), $vinculo->getNrvinculom());
        $this->_gozo_ferias->retornaGozoFerias($vinculo->getNrorg(), $vinculo->getNrvinculom());
        $this->_gozo_ferias->trataGozoFerias(
            $this->_inicio_periodo_saida, $this->_fim_periodo_saida, $this->_mes_competencia
        );
        $mes_1a_parte = $this->_gozo_ferias->getMes1aParte();
        $dias_1a_parte = $this->_gozo_ferias->getDias1aParte();
        $mes_2a_parte = $this->_gozo_ferias->getMes2aParte();
        $dias_2a_parte = $this->_gozo_ferias->getDias2aParte();
        $dias_abono = $this->_gozo_ferias->getDiasAbono();

        if ($dias_1a_parte > 0) {
            $evento = $this->_assoc_eventos->retornaEventoAssociado(
                FpatipoassoceveEntity::ASSOC_FERIAS, $this->_eventom, $this->_nrorg
            );
            $this->_itens_calculo_principal->geraEvento($evento, $mes_1a_parte, 0, $dias_1a_parte, 1);

            $evento = $this->_assoc_eventos->retornaEventoAssociado(
                FpatipoassoceveEntity::ASSOC_ADIC_FERIAS, $this->_eventom, $this->_nrorg
            );
            $this->_itens_calculo_principal->geraEvento($evento, $mes_1a_parte, 0, $dias_1a_parte, 1);

            $evento = $this->_assoc_eventos->retornaEventoAssociado(
                FpatipoassoceveEntity::ASSOC_SUB_TOTAL_FERIAS, $this->_eventom, $this->_nrorg
            );
            $this->_itens_calculo_principal->geraEvento($evento, $mes_1a_parte, 0, $dias_1a_parte, 1);

            // thalesvalias - 01/12/11 - Dias de Ferias para Provisao parametrizado em FPAPARAMFERIASH.
            if ($dias_1a_parte >= $this->_nrDiasFeriasProvisao) {
                // Verificar parametro de provisao.
                $evento = $this->_assoc_eventos->retornaEventoAssociado(
                    FpatipoassoceveEntity::ASSOC_PROVIS_FERIAS_DB, $this->_eventom, $this->_nrorg
                );
                $this->_itens_calculo_principal->geraEvento($evento, $mes_1a_parte, 0, $dias_1a_parte, 1);
            }
            /* alessandrobartels - 05/08/2011 - Implemetacao do adiantamento 13SAL e 13SAL_12AVOS em Ferias. */
            $itemGozo = $this->_gozo_ferias->procuraGozoFerias($this->_gozo_ferias->getDtInicioGozo());

            if ($itemGozo && ($itemGozo->getIdadiant13salar() === FpagozoferiasEntity::IDADIANT13SALAR_SIM)) {
                $evento = $this->_assoc_eventos->retornaEventoAssociado(
                    FpatipoassoceveEntity::ASSOC_ADIANT_13SAL, $this->_eventom, $this->_nrorg
                );
                // thalesvalias - 01/12/11 - Percentual do adiantamento do 13 salario parametrizado em FPAPARAMFERIASH.
                $this->_itens_calculo_principal->geraEvento(
                    $evento, $mes_1a_parte, 0, $this->_vrPercentAdiant13Sal, 1
                );

                $dtInicio = new TkDateTime($vinculo->getDtadmissaovinc(), TkDateTime::FORMAT_DATE);
                $this->_atribuiInicioPeriodo13Salario($dtInicio);
                if ($vinculo->getDtrescisaovinc() === true) {
                    $dtFim = new TkDateTime($vinculo->getDtrescisaovinc(), TkDateTime::FORMAT_DATE);
                } else {
                    $dtFim = null;
                }

                $this->_atribuiFimPeriodo13Salario($dtFim);

                $nrDozeAvos = $this->_calculaNrDozeAvosDecimoTerceiro($vinculo,
                    $this->_inicio_periodo_13sal, $this->_fim_periodo_13sal
                );
                $evento = $this->_assoc_eventos->retornaEventoAssociado(
                    FpatipoassoceveEntity::ASSOC_13SAL_12AVOS, $this->_eventom, $this->_nrorg
                );
                $this->_itens_calculo_principal->geraEvento($evento, $mes_1a_parte, 0, $nrDozeAvos, 1);
            }
        }

        if ($dias_2a_parte > 0) {
            $evento = $this->_assoc_eventos->retornaEventoAssociado(
                FpatipoassoceveEntity::ASSOC_FERIAS_2_PARTE, $this->_eventom, $this->_nrorg
            );
            $this->_itens_calculo_principal->geraEvento($evento, $mes_2a_parte, 0, $dias_2a_parte, 1);

            $evento = $this->_assoc_eventos->retornaEventoAssociado(
                FpatipoassoceveEntity::ASSOC_ADIC_2_PARTE, $this->_eventom, $this->_nrorg
            );
            $this->_itens_calculo_principal->geraEvento($evento, $mes_2a_parte, 0, $dias_2a_parte, 1);

            $evento = $this->_assoc_eventos->retornaEventoAssociado(
                FpatipoassoceveEntity::ASSOC_SUB_TOTAL_FE_2_P, $this->_eventom, $this->_nrorg
            );
            $this->_itens_calculo_principal->geraEvento($evento, $mes_2a_parte, 0, $dias_2a_parte, 1);

            // thalesvalias - 01/12/11 - Dias de Ferias para Provisao parametrizado em FPAPARAMFERIASH.
            if ($dias_2a_parte >= $this->_nrDiasFeriasProvisao) {
                $evento = $this->_assoc_eventos->retornaEventoAssociado(
                    FpatipoassoceveEntity::ASSOC_PROVIS_2_PARTE_DB, $this->_eventom, $this->_nrorg
                );
                $this->_itens_calculo_principal->geraEvento($evento, $mes_2a_parte, 0, $dias_2a_parte, 1);
            }
        }

        if ($dias_abono > 0) {
            $evento = $this->_assoc_eventos->retornaEventoAssociado(
                FpatipoassoceveEntity::ASSOC_ABONO_PECUNIARIO, $this->_eventom, $this->_nrorg
            );
            $this->_itens_calculo_principal->geraEvento($evento, $mes_1a_parte, 0, $dias_abono, 1);

            $evento = $this->_assoc_eventos->retornaEventoAssociado(
                FpatipoassoceveEntity::ASSOC_ADIC_ABONO, $this->_eventom, $this->_nrorg
            );
            $this->_itens_calculo_principal->geraEvento($evento, $mes_1a_parte, 0, $dias_abono, 1);
        }
    }

    /**
     * Enter description here ...
     *
     * @param GpevinculomEntity $vinculo Instancia de GpevinculoEntity.
     * @param $dtinigozo string
     * @param $dtfimgozo string
     * @param $dtretornoferias string
     * @param $dtiniproxper
     * @param $dsferiascoletivas
     * @param $idadian13sal string
     * @param $qtddiasabono string
     *
     * @return void
     *
     * @author brunoborba
     *
     */
    private function _verificaFeriasColetivas(GpevinculomEntity $vinculo,$dtinigozo,$dtfimgozo,$dtretornoferias,$dtiniproxper,$dsferiascoletivas,
                                              $idadian13sal=null,$qtddiasabono=null){

        $this->_ferias->retornaFerias($vinculo->getNrorg(), $vinculo->getNrvinculom());
        $ferias = $this->_ferias->procuraFerias(null);

        if(is_object($ferias)){
            if ($ferias->getIdcontrolferias()== FpaferiasEntity::IDCONTROLFERIAS_ABERTO){
                $dtfimper = new TkDateTime($dtfimgozo);
                $ferias->setIdcontrolferias(FpaferiasEntity::IDCONTROLFERIAS_ADQUIRIDO);
                $ferias->setDtfimaquisicao($dtfimper->addDay(-1));
                $ferias->persist();
            }
            //BORBA 10/02/2013 - Verifica Idade para situação específica dos menores de 18 e maiores de 50
            $pessoa = new GpepessoaEntity();
            $obj_pessoa = $pessoa->retornaPessoa($vinculo->getNrorg(),$vinculo->getNrpessoa());

            if (is_object($obj_pessoa)) {
                $pessoah = new GpepessoahEntity();
                $obj_pessoah = $pessoah->retornaHistoricoAtualPorPessoa($vinculo->getNrorg(),$vinculo->getNrpessoa(),$this->_mes_competencia);

                if (is_object($obj_pessoah)) {
                    $dtnascpessoa=$obj_pessoah->getDtnascpessoa();
                    $dtnascpessoa = new \TkDateTime($dtnascpessoa);
                    $dataAtual    = new \TkDateTime();

                    if ($dataAtual->yearsAfter($dtnascpessoa) > 50 || $dataAtual->yearsAfter($dtnascpessoa) < 18) {
                        $dt_inigozo= new TkDateTime($dtinigozo);
                        $dtfimgozo=$dt_inigozo->addDay(29);
                        tk_warning($dtinigozo.' '.$dtfimgozo);
                    }
                }
            }
            //BORBA 10/02/2013 - Verifica já existe gozo para o período antes de lançá-lo.
            $this->_gozo_ferias->retornaGozoFerias($vinculo->getNrorg(), $vinculo->getNrvinculom());
            $itemGozo = $this->_gozo_ferias->procuraGozoFerias($dtinigozo);

            if(is_object($itemGozo)){
                //@todo MsgCalculo
                MsgCalculo::getInstance()->adicionaMensagem('Já existe um período de gozo lançado para o vínculo com data de início: '.$dtinigozo);
                //tk_warning('Já existe um período de gozo lançado para o vínculo '.$vinculo->getNmvinculom().' com data de início: '.$dtinigozo );
            }else{
                $this->_gozo_ferias->incluiGozoFerias($vinculo->getNrorg(),$ferias->getNrferias(),$dtinigozo,$dtfimgozo,0,
                    $dtretornoferias,'N');
            }

        }


    }


    /**
     * Enter description here ...
     *
     * @param FpatpcalcmovEntity $tp_calc_mov Instancia de FpatpcalcmovEntity.
     *
     * @return void
     *
     * @throws Exception $e Excessao.
     *
     * @author alessandrobartels
     */
    private function _atribuiIteCalcEspecificoRescisao(FpatpcalcmovEntity $tp_calc_mov){

        if ($this->_nr_tipo_calculo === FpatipocalculoEntity::CALC_PROVISAO_CONTABIL) {
            $this->_ferias_vencidas = FpatipomovimentEntity::TP_MOV_PROV_FERIAS_VENC;
            $this->_ferias_proporcionais = FpatipomovimentEntity::TP_MOV_PROV_FERIAS_PROP;
            $this->_decimo_terceiro_sal = FpatipomovimentEntity::TP_MOV_PROV_13SAL;
            $this->_aviso_previo = FpatipomovimentEntity::TP_MOV_PROV_AVISO_PREVIO;   // borba 20/02/2013
        } else {
            // Rescisao ou Rescisao complementar.
            $this->_ferias_vencidas = FpatipomovimentEntity::TP_MOV_FERIAS_VENC_RESC;
            $this->_ferias_proporcionais = FpatipomovimentEntity::TP_MOV_FERIAS_PROP_RESC;
            $this->_decimo_terceiro_sal = FpatipomovimentEntity::TP_MOV_13SAL_RESC;
            $this->_aviso_previo = FpatipomovimentEntity::TP_MOV_AVISO_PREVIO_RESC;
        }

        try{
            $obj_tp_calc_mov = $tp_calc_mov->retornaPosicaoTpMov($this->_ferias_vencidas);
            /* Na rescisao os vinculos podem ter varias ferias vencidas */
            foreach ($obj_tp_calc_mov as $obj) {
                $this->_itens_ferias_vencidas[] =  $obj->getInstancia();
            }
        } catch(Exception $e){
            $message = $e->getMessage();
            $message .= ' - Ferias Vencidas PREPARACAO.PHP';
            //@todo MsgCalculo
            MsgCalculo::getInstance()->adicionaMensagem('Ferias Vencidas - '.$e->getMessage());
            //throw new Exception($message);
        }

        try{
            $obj_tp_calc_mov = current(
                $tp_calc_mov->retornaPosicaoTpMov($this->_ferias_proporcionais)
            );
           $this->_itens_ferias_proporcionais =  $obj_tp_calc_mov->getInstancia();

        } catch(Exception $e){
            $message = $e->getMessage();
            $message .= ' - Férias Proporcionais PREPARACAO.PHP';
            //@todo MsgCalculo
            MsgCalculo::getInstance()->adicionaMensagem('Férias Proporcionais - '.$e->getMessage());
            //throw new Exception($message);
        }

        try{
            $obj_tp_calc_mov = current(
                $tp_calc_mov->retornaPosicaoTpMov($this->_decimo_terceiro_sal)
            );
            $this->_itens_13sal =  $obj_tp_calc_mov->getInstancia();

        } catch(Exception $e){
            $message = $e->getMessage();
            $message .= ' - 13 Salário PREPARACAO.PHP';
            //@todo MsgCalculo
            MsgCalculo::getInstance()->adicionaMensagem('13º Salário - '.$e->getMessage());
            //throw new Exception($message);
        }

        try{
            $obj_tp_calc_mov = current(
                $tp_calc_mov->retornaPosicaoTpMov($this->_aviso_previo)
            );
            $this->_itens_aviso_previo =  $obj_tp_calc_mov->getInstancia();

        } catch(Exception $e){
            $message = $e->getMessage();
            $message .= ' - Aviso Prévio PREPARACAO.PHP';
            //@todo MsgCalculo
            MsgCalculo::getInstance()->adicionaMensagem('Aviso Prévio - '.$e->getMessage());
            //throw new Exception($message);
        }


    }


    /**
     * Prepara cabecalho para impressao de preparacao em tela.
     *
     * @param GpevinculomEntity $vinculo       Instancia de GpevinculomEntity.
     * @param Demonstrativo     $demonstrativo Instancia de Demonstrativo.
     * @param integer           $contador      Contador.
     *
     * @return Elemento
     */
    private function _preparaCabecalho(GpevinculomEntity $vinculo, Demonstrativo $demonstrativo, $contador){
        $pessoa = $this->_pessoa->retornaPessoaAtual($vinculo->getNrpessoa());
        $nmPessoa = $pessoa->historico->getNmpessoa();

        $salario = null;

        /* Teste data admissao do vinculo. */
        //$dtAdmissao = $vinculo->getDtadmissaovinc();

        /* Teste data admissao do vinculo. Tratamento para retirar a hora. ex de valor indesejado 11/08/2010 00:00:00*/
        $dtAdmissao = explode(' ', $vinculo->getDtadmissaovinc()); // Borba 21/02/2013
        $dtAdmissao = $dtAdmissao[0];                              // Borba 21/02/2013

        $dataAux = new TkDateTime($dtAdmissao, TkDateTime::FORMAT_DATE);
        $dataAux->setDay(1);
        if ($dataAux->equals($this->_mes_competencia) === true) {
            $dataAux->set($dtAdmissao);
            $dtAdmissao = $dataAux->toString(TkDateTime::FORMAT_DATE);
        } else {
            //    $dtAdmissao = null;
        }

        /* Teste data rescisao do vinculo. */
        $dtRescisao = $vinculo->getDtrescisaovinc();
        if (empty($dtRescisao) !== true) {
            $dataAux = new TkDateTime($dtRescisao, TkDateTime::FORMAT_DATE);
            $dataAux->setDay(1);
            if ($dataAux->equals($this->_mes_competencia) === true) {
                $dataAux->set($dtRescisao);
                $dtRescisao = $dataAux->toString(TkDateTime::FORMAT_DATE);
            } else {
                $dtRescisao = null;
            }
        } else {
            $dtRescisao = null;
        }

        if ($this->_nr_tipo_calculo === FpatipocalculoEntity::CALC_FERIAS) {
            /* Teste periodo de gozo de ferias do vinculo. */
            $dtIniGozo = $this->_gozo_ferias->getDtInicioGozo()->toString(TkDateTime::FORMAT_DATE);
            if (empty($dtIniGozo) !== true) {
                $dataAux = new TkDateTime($dtIniGozo, TkDateTime::FORMAT_DATE);
                $dataAux->setDay(1);
                if ($dataAux->equals($this->_mes_competencia) === true) {
                    $periodoGozo = $dtIniGozo;
                    $periodoGozo .= '  -  '.$this->_gozo_ferias->getDtFimGozo()->toString(TkDateTime::FORMAT_DATE);
                } else {
                    $periodoGozo = null;
                }
            } else {
                $periodoGozo = null;
            }
        }

        unset($dataAux);

        $demonstrativo->montaCabecalho(
            $vinculo->getCdmatricula(), $vinculo->getNrvinculom(), $nmPessoa, $salario, $dtAdmissao, $dtRescisao,
            $periodoGozo
        );

        $elementoDemonstrativo = $demonstrativo->addElemento(null, $contador);

        return $elementoDemonstrativo;
    }


}