package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;

import javax.swing.*;

public class CadastroTipoDePratoPage extends PageBase {

    //Cadastro Tipo de Prato
    By usernameLoginInfoTextArea = By.xpath("//*[@class = 'navbar-brand zh-header-title has-header-info']");
    By msgConfirmaTela = By.xpath("//div[@class = 'navbar-brand zh-header-title has-header-info']");
    By botaoInicial = By.xpath("//*[@type = 'button']");
    By displayInicio = By.xpath("//*[@type = 'button']");
    By clicarBotao = By.xpath("//*[@class = 'menu-link'] //*[contains(text(),'Parametrização')]");
    By clicaPlanejamento = By.xpath("//ul[@class = 'sub-menu']//*[contains(text(),'Planejamento')]");
    By clicaEmPrato = By.xpath("//ul[@class = 'sub-menu']//li[@class = 'menu-item closed sub-menu-item has-child visible']//span[@class = 'menu-link']//*[contains(text(),'Prato')]");
    By tipoPrato = By.xpath("/html/body/span/section/section/div[2]/section[1]/div/aside/div[2]/nav/ul/li[1]/ul/li[20]/ul/li[3]/ul/li[1]/ul/li[2]/span");
    By msgEsperada = By.xpath("//div[contains(text(),'Tipo de Prato')]");
    By botaoAdicionar = By.xpath("//li[@data-zh-id='41996933698328914326']");
    By codTipoPrato = By.xpath("//input[@id = 'CDTIPOPRAT']");
    By nmTipoPrato = By.xpath("//input[@id = 'NMTIPOPRAT']");
    By nmReduzTipoPrato = By.xpath("//input[@id = 'NMREDUZIDO']");
    By salvaTipoPrato = By.xpath("//li[@data-zh-id='41996933620751020994332']");
    By msgConfirCadastro = By.xpath("//span[.='SALADA']");


    //Alteração Tipo de Prato
    By btnEditar = By.xpath("//div[@class = 'zh-footer-center']//li[@data-zh-id='41996933612129910994328']");
    By lupaGrupo = By.xpath("//span[@zh-icon = 'no-border search']");
    By idSobreLimpa = By.xpath("//*[@for = 'zh-checkbox-IDSOBRLIMPTP']//div[@class = 'zh-box mousetrap zh-ripple-effect']");
    By idMedicaoKg = By.xpath("//*[@for = 'zh-checkbox-IDMEDICAOKG']//div[@class = 'zh-box mousetrap zh-ripple-effect']");
    By limpaFiltro = By.xpath("//span[@zh-icon = 'no-border close-x']");
    By buscaGrupo = By.xpath("//*[@id='popup']/span/section/section/section/section/div/div[2]/div/div[1]/ul/li[2]/div/div/div/div[3]/input");
    By clickGrupo = By.xpath("//*[@id='grid-41996933611901253144317']//span[contains(text(),'50')]");
    By selecionaGrupo = By.xpath("//*[@id='grid-9000']/div[2]/div/div[1]");
    By salvaEdicao = By.xpath("//li[@data-zh-id='41996933620751020994332']");
    By voltaTela = By.xpath("//li[@data-zh-id='4199693368856806954336']");

    //Eclusão Tipo de Prato
    By btnExcluir = By.xpath("//li[@data-zh-id='41996933614279302634330']");
    By mscConfirmacao = By.xpath("//button[@class = 'zh-alert-button horizontal']//span[contains(text(),'Sim')]");

    public void clicarMenuPrincipal() {
        waitForElement(displayInicio);
        tempo();
        waitForElement(usernameLoginInfoTextArea);
        tempo();
        click(botaoInicial);
        tempo();
        click(clicarBotao);
    }

    public void clicarPlanejamento(){
        click(clicaPlanejamento);
    }

    public void clicarPrato(){
        waitForVisibilityOfElementLocated(clicaEmPrato);
        click(clicaEmPrato);
        ScrollToTop();
        waitForVisibilityOfElementLocated(tipoPrato);
        click(tipoPrato);
    }

    public String mensagemEsperada(){
        return getText(msgEsperada);
    }

    //Inclusão
    public void adicionaTipoDePrato(String codigo, String nome, String nomeReduzido, String nmGrupo){
        click(botaoAdicionar);
        tempo();
        click(codTipoPrato);
        tempo();
        sendKeys(codTipoPrato,codigo);
        click(nmTipoPrato);
        sendKeys(nmTipoPrato,nome);
        click(nmReduzTipoPrato);
        sendKeys(nmReduzTipoPrato,nomeReduzido);
      //  click(limpaFiltro);
        click(lupaGrupo);
        click(buscaGrupo);
        sendKeys(buscaGrupo,nmGrupo);
        tempo();
        click(selecionaGrupo);

       // click(idSobreLimpa);
       // click(idMedicaoKg);
        click(salvaTipoPrato);
    }

    public String confirmaCadastro(){
        tempo();
        return getText(msgConfirCadastro);
    }

    //Alteração
    public void alteraTipoDePrato(String nmNovo,String nmGrupo){
        click(clickGrupo);
        tempo();
        click(btnEditar);
        tempo();
        click(nmTipoPrato);
        tempo();
        clearAndSendKeys(nmTipoPrato,nmNovo);
        tempo();
        click(limpaFiltro);
        tempo();
        click(lupaGrupo);
        tempo();
        click(buscaGrupo);
        tempo();
        sendKeys(buscaGrupo,nmGrupo);
        tempo();
        click(selecionaGrupo);
        tempo();
        click(idSobreLimpa);
        tempo();
        click(idMedicaoKg);
        tempo();
        click(salvaEdicao);
        tempo();
        click(voltaTela);
        tempo();
    }
    //Exclusão
    public void excluirTipodePrato(){
        click(clickGrupo);
        tempo();
        click(btnExcluir);
        tempo();
        click(mscConfirmacao);
        tempo();

    }
}
