package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;
import org.testng.Assert;

import java.util.ArrayList;
import java.util.List;

public class EmissaoCardapioMesPage extends PageBase {

    By botaoMenu = By.xpath("//div[@class='bars']");
    By campoPesquisar = By.xpath("//section[@class='zh-container-search-menu']//input[@type='text']");
    By selecionarOpcaoEmissaoCarpioMes = By.xpath("//span[text() = 'Emissão do Cardápio do Mês']");

    By campoRelatorio = By.xpath("//div[@data-zh-id=\"21297488195420208521274\"]//div[@class=\"new-select input-text form-input-margin-bottom mousetrap form-control zh-text-align-{{field.align || 'left'}} ng-pristine ng-untouched ng-valid\"]");
    By relatorioEmissaoCardapioMes = By.xpath("//div[@data-zh-id=\"21297488195420208521274\"]//li[text() = 'Emissão do Cardápio do Mês']");
    By relatorioCentralizado = By.xpath("//div[@data-zh-id=\"21297488195420208521274\"]//li[text() = 'Emissão do Cardápio do Mês (Centralizado)']");
    By relatorioInativoReceita = By.xpath("//div[@data-zh-id=\"21297488195420208521274\"]//li[text() = 'Cardápios com Produto Inativo na Receita']");
    By relatorioInativoReceitaGeral = By.xpath("//div[@data-zh-id=\"21297488195420208521274\"]//li[text() = 'Cardápios com Produto Inativo na Receita (Geral)']");
    By relatorioDezColunas = By.xpath("//div[@data-zh-id=\"21297488195420208521274\"]//li[text() = 'Emissão do Cardápio do Mês (10 Colunas)']");
    By relatorioCusto = By.xpath("//div[@data-zh-id=\"21297488195420208521274\"]//li[text() = 'Emissão do Cardápio do Mês (Custo)']");
    By relatorioCustoTipoPrato = By.xpath("//div[@data-zh-id=\"21297488195420208521274\"]//li[text() = 'Emissão do Cardápio do Mês (Custo Tipo de Prato)']");
    By relatorioPeriodoPagina = By.xpath("//div[@data-zh-id=\"21297488195420208521274\"]//li[text() = 'Emissão do Cardápio do Mês (Período por Página)']");

    By campoAgrupoamentoUnidades = By.id("NMGRUPFILI");
    By agrupamentoProdutoAcabado = By.xpath("//div[@data-zh-id=\"212974881926205441631277\"]//span[text() = '0000000001 | PRODUCAO - PRODUTO ACABADO']");

    By checkBoxTodasUnidades = By.id("zh-checkbox-ALLCDFILIAL");
    By todasUnidades = By.xpath("//div[@data-zh-id=\"212974881913094336941292\"]//div[@class=\"zh-box mousetrap zh-ripple-effect\"]");
    By campoUnidade = By.id("NMFILIAL");
    By unidadeDepositoBc129 = By.xpath("//div[@data-zh-field-name=\"NMFILIAL\"]//span[text() = 'DEPOSITO BC 129']");
    By campoUnidadeUnica = By.id("NMFILIAL1");
    By unidadeJabaquara = By.xpath("//div[@data-zh-id=\"212974881917058361181283\"]//span[text() = '0002 | DEPOSITO JABAQUARA']");

    By checkBoxTodosServicos = By.id("zh-checkbox-ALLCDSERVFILI");
    By todosServicos = By.xpath("//div[@data-zh-id=\"212974881941541043571306\"]//div[@class=\"zh-box mousetrap zh-ripple-effect\"]");
    By campoServico = By.id("NMSERVICO");
    By servicoAlmoco = By.xpath("//div[@data-zh-field-name=\"NMSERVICO\"]//span[text() = 'ALMOÇO']");
    By servicoSolicitcao = By.xpath("//div[@data-zh-field-name=\"NMSERVICO\"]//span[text() = 'SOLICITACAO']");
    By servicoDistribuicao = By.xpath("//div[@data-zh-field-name=\"NMSERVICO\"]//span[text() = 'DISTRIBUICAO']");
    By servicoAlmocoFaturamento = By.xpath("//div[@data-zh-field-name=\"NMSERVICO\"]//span[text() = 'ALMOÇO FATURAMENTO']");
    By servicoAlmocoEspecial = By.xpath("//div[@data-zh-field-name=\"NMSERVICO\"]//span[text() = 'ALMOÇO ESPECIAL']");
    By botaoOk = By.xpath("//section[@class=\"popup-container\"]//div[@class=\"zh-footer-right\"]");

    By campoMesInicial = By.id("MESINICIO");
    By campoMesFinal = By.id("MESFINAL");
    By mesOutubro = By.xpath("//div[@class=\"calendar\"]//div[text() = 'Out']");
    By mesNovembro = By.xpath("//div[@class=\"calendar\"]//div[text() = 'Nov']");
    By botaoMesInicial = By.xpath("//div[@id=\"MESINICIO\"]//span[@zh-icon=\"no-border close-x\"]");
    By botaoMesFinal = By.xpath("//div[@id=\"MESFINAL\"]//span[@zh-icon=\"no-border close-x\"]");

    By botaoRelatorio = By.xpath("//div[@class=\"zh-footer-right\"]");
    By tipoPdf = By.xpath("//label[@for=\"radio-QR2TYPE-PDF\"]//div[@class=\"zh-circle mousetrap zh-ripple-effect\"]");
    By botaoConfirmar = By.xpath("//section[@class=\"popup-container\"]//div[@class=\"zh-footer-right\"]");

    By mensagemObrigatorioUnidade = By.xpath("//div[@data-zh-id=\"212974881935456362811288\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioServico = By.xpath("//div[@data-zh-id=\"212974881923042825861299\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioMesInicial = By.xpath("//div[@data-zh-id=\"212974881920701616591294\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatoiroMesFinal = By.xpath("//div[@data-zh-id=\"212974881924362402271296\"]//div[@class=\"zh-validation\"]/span");

    By imprimirMensagem = By.xpath("//div[@data-zh-id=\"21297488196614135011309\"]//div[@class=\"zh-box mousetrap zh-ripple-effect\"]");
    By imprimirNomeFantasia = By.xpath("//div[@data-zh-id=\"21297488195275150871310\"]//div[@class=\"zh-box mousetrap zh-ripple-effect\"]");
    By imprimirDiasSemCardapio = By.xpath("//div[@data-zh-id=\"212974881913394873451311\"]//div[@class=\"zh-box mousetrap zh-ripple-effect\"]");
    By imprimir = By.xpath("//div[@data-zh-id=\"212974881932832875761312\"]//div[@class=\"zh-box mousetrap zh-ripple-effect\"]");

    By checkBoxImprimirMensagem = By.id("zh-checkbox-MENS");
    By checkBoxImprimirNomeFantasia = By.id("zh-checkbox-IMPNMFANTA");
    By checkBoxImprimirDiasSemCardapio = By.id("zh-checkbox-IMPDIASSEMCARD");
    By checkBoxImprimir = By.id("zh-checkbox-IMPCOMEN");

    By comensaisNumero = By.xpath("//label[@for=\"radio-TPIMPRESSAO-T\"]//div[@class=\"zh-circle mousetrap zh-ripple-effect\" and @contenteditable=\"true\"]");
    By comensaisPercentual = By.xpath("//label[@for=\"radio-TPIMPRESSAO-N\"]//div[@class=\"zh-circle mousetrap zh-ripple-effect\" and @contenteditable=\"true\"]");
    By radioButtonNumero = By.id("radio-TPIMPRESSAO-T");
    By radioButtonPercentual = By.id("radio-TPIMPRESSAO-N");

    By botaoTipoCusto = By.xpath("//div[@id=\"NMTPCUSTO\"]//span[@style=\"background-image: none; display: block;\"]");
    By mensagemObrigatorioTipoCusto = By.xpath("//div[@data-zh-id=\"212974881931617880511308\"]//div[@class=\"zh-validation\"]/span");

    By campoMensagemAlerta = By.xpath("//section[@class=\"zh-container-alert\"]//p[@class=\"zh-text-alert\"]");
    By botaoOkAlerta = By.xpath("//section[@class=\"zh-container-alert\"]//button[@class=\"zh-alert-button\"]");

    public void acessarTela() {
        tempoParaAguardarTelaInicial();
        waitForElement(botaoMenu);
        click(botaoMenu);
        sendKeys(campoPesquisar, "Emissão do Cardápio do Mês");
        click(selecionarOpcaoEmissaoCarpioMes);
    }

    public void selecionarRelatorio(String nomeRelatorio) {
        if (nomeRelatorio == "Emissão do Cardápio do Mês") {
            clicarCampoSelecionarValor(campoRelatorio, relatorioEmissaoCardapioMes);
        } else if (nomeRelatorio == "Emissão do Cardápio do Mês (Centralizado)") {
            clicarCampoSelecionarValor(campoRelatorio, relatorioCentralizado);
        } else if (nomeRelatorio == "Cardápios com Produto Inativo na Receita") {
            clicarCampoSelecionarValor(campoRelatorio, relatorioInativoReceita);
        } else if (nomeRelatorio == "Cardápios com Produto Inativo na Receita (Geral)") {
            clicarCampoSelecionarValor(campoRelatorio, relatorioInativoReceitaGeral);
        } else if (nomeRelatorio == "Emissão do Cardápio do Mês (10 Colunas)") {
            clicarCampoSelecionarValor(campoRelatorio, relatorioDezColunas);
        } else if (nomeRelatorio == "Emissão do Cardápio do Mês (Custo)") {
            clicarCampoSelecionarValor(campoRelatorio, relatorioCusto);
        } else if (nomeRelatorio == "Emissão do Cardápio do Mês (Custo Tipo de Prato)") {
            clicarCampoSelecionarValor(campoRelatorio, relatorioCustoTipoPrato);
        } else if (nomeRelatorio == "Emissão do Cardápio do Mês (Período por Página)") {
            clicarCampoSelecionarValor(campoRelatorio, relatorioPeriodoPagina);
        }
    }

    public void selecionarAgrupamento() {
        clicarCampoSelecionarValor(campoAgrupoamentoUnidades, agrupamentoProdutoAcabado);
    }

    public void selecionarDepositoBc129() {
            click(todasUnidades);
            click(campoUnidade);
            click(unidadeDepositoBc129);
            click(botaoOk);
    }

    public void selecionarServicos() {
        click(todosServicos);
        click(campoServico);
        click(servicoAlmoco);
        click(servicoSolicitcao);
        click(servicoDistribuicao);
        click(botaoOk);
    }

    public void selecionarUnidadeJabaquara() {
        clicarCampoSelecionarValor(campoUnidadeUnica, unidadeJabaquara);
        click(todosServicos);
        click(campoServico);
        click(servicoAlmocoFaturamento);
        click(servicoAlmocoEspecial);
        click(botaoOk);
    }

    public void selecionarMeses() {
        clicarCampoSelecionarValor(campoMesInicial, mesOutubro);
        clicarCampoSelecionarValor(campoMesFinal, mesNovembro);
    }

    public void gerarRelatorio() {
        click(botaoRelatorio);
        click(tipoPdf);
        click(botaoConfirmar);
        fecharGuiaDoRelatorio();
    }

    private void fecharGuiaDoRelatorio() {
        tempo();
        tempo();
        String winHandleBefore = driver.getWindowHandle();
        List<String> aba = new ArrayList<>(driver.getWindowHandles());
        driver.switchTo().window(aba.get(1));
        driver.getCurrentUrl();
        driver.close();
        driver.switchTo().window(winHandleBefore);
    }

    public void campoObrigatorios() {
        click(todosServicos);
        click(botaoMesInicial);
        click(botaoMesFinal);
        click(botaoRelatorio);

        String mensagemUnidade = getText(mensagemObrigatorioUnidade);
        String mensagemServico = getText(mensagemObrigatorioServico);
        String mensagemMesInicial = getText(mensagemObrigatorioMesInicial);
        String mensagemMesFinal = getText(mensagemObrigatoiroMesFinal);

        String mensagemEsperada = "Campo obrigatório";
        Assert.assertEquals(mensagemUnidade, mensagemEsperada, "Verificação da mensagem de campo obrigatório no campo unidade");
        Assert.assertEquals(mensagemServico, mensagemEsperada, "Verificação da mensagem de campo obrigatório no campo serviço");
        Assert.assertEquals(mensagemMesInicial, mensagemEsperada, "Verificação da mensagem de campo obrigatório no campo mês inicial");
        Assert.assertEquals(mensagemMesFinal, mensagemEsperada, "Verificação da mensagem de campo obrigatório no campo mês final");
    }

    public void verificarTodasUnidadeServico() {
        boolean checkUnidade = returnIfElementIsSelected(checkBoxTodasUnidades);
        Assert.assertEquals(checkUnidade, false, "Verificar se no momento que a tela carrega o checkBox todas unidades está desmarcado");

        click(todasUnidades);
        checkUnidade = returnIfElementIsSelected(checkBoxTodasUnidades);
        Assert.assertEquals(checkUnidade, true, "Verificar se após clicar em todas unidades, o checkBox está marcado");

        boolean checkServico = returnIfElementIsSelected(checkBoxTodosServicos);
        Assert.assertEquals(checkServico, true, "Verificar se no momento em que a tela carrega o checkBox todos serviços já está marcado");

        click(todosServicos);
        checkServico = returnIfElementIsSelected(checkBoxTodosServicos);
        Assert.assertEquals(checkServico, false, "Verificar se após clicar em todos serviços, o checkBox fica desmarcado");
    }

    public void marcarCheckBoxs() {
        boolean checkImprimirDiasSemCardapio = returnIfElementIsSelected(checkBoxImprimirDiasSemCardapio);
        Assert.assertEquals(checkImprimirDiasSemCardapio, true, "Verificar se o checkbox imprimir dias sem cardápio está selecionado");
        click(imprimirDiasSemCardapio);
        checkImprimirDiasSemCardapio = returnIfElementIsSelected(checkBoxImprimirDiasSemCardapio);
        Assert.assertEquals(checkImprimirDiasSemCardapio, false, "Verificar se o checkbox imprimir dias sem cardápio não está mais selecionado após clicar no mesmo");

        boolean checkImprimirMensagem = returnIfElementIsSelected(checkBoxImprimirMensagem);
        Assert.assertEquals(checkImprimirMensagem, false, "Verificar se o checkbox imprimir mensagem não está selecionado");
        click(imprimirMensagem);
        checkImprimirMensagem = returnIfElementIsSelected(checkBoxImprimirMensagem);
        Assert.assertEquals(checkImprimirMensagem, true, "Verificar se o checkbox imprimir mensagem está selecionado, após clicar no mesmo");

        boolean checkImprimirNomeFantasia = returnIfElementIsSelected(checkBoxImprimirNomeFantasia);
        Assert.assertEquals(checkImprimirNomeFantasia, false, "Verificar se o checkbox imprimir mensagem não está selecionado");
        click(imprimirNomeFantasia);
        checkImprimirNomeFantasia = returnIfElementIsSelected(checkBoxImprimirNomeFantasia);
        Assert.assertEquals(checkImprimirNomeFantasia, true, "Verificar se o checkbox imprimir nome fantasia está selecionado, após clicar no mesmo");

        boolean checkImprimir = returnIfElementIsSelected(checkBoxImprimir);
        Assert.assertEquals(checkImprimir, true, "Verificar se o checkbox imprimir está selecionado");
        click(imprimir);
        Assert.assertEquals(checkImprimirDiasSemCardapio, false, "Verificar se o checkbox imprimir  não está mais selecionado após clicar no mesmo");
    }

    public void marcarComensais() {
        boolean checkImprimir = returnIfElementIsSelected(checkBoxImprimir);
        Assert.assertEquals(checkImprimir, true,"Verificar se o campo imprimir está selecionado");

        boolean radioNumero = returnIfElementIsSelected(radioButtonNumero);
        Assert.assertEquals(radioNumero, true, "Verificar se a comensais número está selecionada");

        click(comensaisPercentual);
        boolean radioPercentual = returnIfElementIsSelected(radioButtonPercentual);
        Assert.assertEquals(radioPercentual, true, "Verificar se a comensais de percentual está marcada após clicar na mesma");
        radioNumero = returnIfElementIsSelected(radioButtonNumero);
        Assert.assertEquals(radioNumero, false, "Verificar se após selecionar a comensais de percentual, a de números não está mais selecionada");

        click(imprimir);
        checkImprimir = returnIfElementIsSelected(checkBoxImprimir);
        Assert.assertEquals(checkImprimir, false, "Verificar se o checkbox imprimir ainda está selecionado após clicar nele");

        boolean campoNumero = returnIfElementIsEnabled(radioButtonNumero);
        boolean campoPercentual = returnIfElementIsEnabled(radioButtonPercentual);
        Assert.assertEquals(campoNumero, false, "Verificar se o campo número está habilitado após desmarcar o imprimir");
        Assert.assertEquals(campoPercentual, false, "Verificar se o campo percentual está habilitado após desmarcar o imprimir");
    }

    public void verificarCampoObrigatorioTipoCusto() {
        clicarCampoSelecionarValor(campoRelatorio, relatorioCustoTipoPrato);
        click(botaoTipoCusto);
        click(botaoRelatorio);

        String mensagemTipoCusto = getText(mensagemObrigatorioTipoCusto);
        String mensagemEsperada = "Campo obrigatório";
        Assert.assertEquals(mensagemTipoCusto, mensagemEsperada, "Verificação da mensagem de campo obrigatório, no campo tipo de custo");
    }

    public void selecionarMesesIncorrentos() {
        click(todasUnidades);
        clicarCampoSelecionarValor(campoMesInicial, mesNovembro);
        clicarCampoSelecionarValor(campoMesFinal, mesOutubro);
        click(botaoRelatorio);

        String mensagemAlerta = getText(campoMensagemAlerta);
        String mensagemEsperada = "O mês inicial deve ser menor ou igual ao mês final.";
        Assert.assertEquals(mensagemAlerta, mensagemEsperada, "Verificar a mensagem que é exibida na tela após selecionar um mês inicial maior que o final");
        click(botaoOkAlerta);

        clicarCampoSelecionarValor(campoMesInicial, mesOutubro);
        clicarCampoSelecionarValor(campoMesFinal, mesNovembro);
        gerarRelatorio();
    }

}
















