package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;
import org.openqa.selenium.Keys;
import org.openqa.selenium.WebElement;
import org.openqa.selenium.interactions.Actions;
import org.testng.Assert;

public class RetiradaPlanejamentoPage extends PageBase {

    By botaoMenu = By.xpath("//div[@class='bars']");
    By campoPesquisar = By.xpath("//section[@class='zh-container-search-menu']//input[@type='text']");
    By telaRetiradaPlanejamento = By.xpath("//span[text() = 'Retirada (Planejamento)']");

    By campoUnidade = By.id("NMFILIAL");
    By unidadeJabaquara = By.xpath("//div[@data-zh-id=\"249399591780718684326\"]//span[text() = '0002 | DEPOSITO JABAQUARA']");
    By unidadeBc111 = By.xpath("//div[@data-zh-id=\"249399591780718684326\"]//span[text() = '0003 | DEPOSITO BC 111']");

    By campoServico = By.id("NMSERVICO");
    By servicoAlmocoEspecial = By.xpath("//div[@data-zh-id=\"2493995912104281832707\"]//span[text() = '00002 | ALMOÇO ESPECIAL']");
    By servicoRetiradas = By.xpath("//div[@data-zh-id=\"2493995912104281832707\"]//span[text() = '00001 | RETIRADAS']");

    By campoDataRetirada = By.id("DTRETIRADA");
    By botaoAplicarFiltro = By.xpath("//section[@class=\"popup-container\"]//div[@class=\"zh-footer-right\"]");
    By botaoLimparUnidade = By.xpath("//div[@id='NMFILIAL']//span[@style=\"background-image: none; display: block;\"]");
    By botaoLimparDataRetirada = By.xpath("//div[@class=\"zh-select-date zh-field-DTRETIRADA\"]//span[@style=\"background-image: none; display: block;\"]");
    By botaoLimparNumRequisicao = By.xpath("//div[@id='NRREQUEXTRRE']//span[@style=\"background-image: none; display: block;\"]");
    By botaoLimparAlmoxarifado = By.xpath("//div[@id='DSALMOXARIFE']//span[@style=\"background-image: none; display: block;\"]");
    By botaoLimparTipoRetirada = By.xpath("//div[@id='NMTIPORETI']//span[@style=\"background-image: none; display: block;\"]");

    //mensagem de campo obrigatório do filtro inicial
    By mensagemObrigatorioUnidadeIni = By.xpath("//div[@data-zh-id=\"249399591780718684326\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioServicoIni = By.xpath("//div[@data-zh-id=\"2493995912104281832707\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioDataRetiradaIni = By.xpath("//div[@data-zh-id=\"24939959137243723022711\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioDataCardapioIni = By.xpath("//div[@data-zh-id=\"24939959126392878562713\"]//div[@class=\"zh-validation\"]/span");

    //mensagem de campo obrigatório do filtro nova retirada
    By mensagemObrigatorioServicoNovaRetirada = By.xpath("//div[@data-zh-id=\"24939959139354777442723\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioNumRequisicaoNovaRetirada = By.xpath("//div[@data-zh-id=\"24939959131877350912732\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioDataRetiradaNovaRetirada = By.xpath("//div[@data-zh-id=\"2493995917434920092728\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioDataCardapioNovaRetirada = By.xpath("//div[@data-zh-id=\"24939959142047341522730\"]//div[@class=\"zh-validation\"]/span");

    //mensagem de campo obrigatório do cadastro de adicionar retirada
    By mensagemObrigatorioTipoPrato = By.xpath("//div[@data-zh-id=\"2493995913344106762829\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioPrato = By.xpath("//div[@data-zh-id=\"249399591592251592832\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioProduto = By.xpath("//div[@data-zh-id=\"24939959129913704632836\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioQuantExtra = By.xpath("//div[@data-zh-id=\"24939959115300353362845\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioQuantDevolvida = By.xpath("//div[@data-zh-id=\"2493995918287041042848\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioQuantConsumida = By.xpath("//div[@data-zh-id=\"24939959142298878422851\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioLote = By.xpath("//div[@class=\"col-xs-5 zh-field\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioAlmoxarifado = By.xpath("//div[@class=\"col-xs-6 zh-field\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioTipoRetirada = By.xpath("//div[@data-zh-id=\"24939959115513766182841\"]//div[@class=\"zh-validation\"]/span");

    By campoMensagemAlerta = By.xpath("//section[@class=\"zh-container-alert\"]//p[@class=\"zh-text-alert\"]");
    By botaoSimAlerta = By.xpath("//section[@class=\"zh-container-alert\"]//button[@data-zh-id=\"zh-footer-alert-button-0\"]");
    By botaoOkAlerta = By.xpath("//section[@class=\"zh-container-alert\"]//button[@class=\"zh-alert-button\"]");

    By botaoAdicionar = By.xpath("//div[@class=\"zh-footer-center\"]//li[@class=\"zh-ripple-effect\"]");
    By botaoExcluir = By.xpath("//div[@class=\"zh-footer-center\"]//li[@class=\"zh-ripple-effect\"]");
    By botaoConfirmar = By.xpath("//section[@class=\"popup-container\"]//div[@class=\"zh-footer-right\"]");
    By botaoVoltar = By.xpath("//div[@class=\"zh-footer-left\"]");
    By botaoVoltarAcoes = By.xpath("//section[@class=\"popup-container\"]//div[@class=\"zh-footer-left\"]");
    By botaoAcoes = By.xpath("//div[@class=\"zh-footer-right\"]");
    By botaoCancelarPopupContainer = By.xpath("//section[@class=\"popup-container\"]//div[@class=\"zh-footer-left\"]");
    By botaoCancelar = By.xpath("//div[@class=\"zh-footer-left\"]");
    By botaoPesquisarTipoPrato = By.xpath("//div[@id=\"NMTIPOPRAT\"]//span[@style=\"background-image: none; display: block;\"]");
    By botaoPesquisarPrato = By.xpath("//div[@id=\"NMPRATO\"]//span[@style=\"background-image: none; display: block;\"]");
    By botaoPesquisarProduto = By.xpath("//div[@id=\"NMPRODUTO\"]//span[@style=\"background-image: none; display: block;\"]");
    By botaoPesquisarTipoRetirada = By.xpath("//div[@id='NMTIPORETI']//span[@style=\"background-image: none; display: block;\"]");

    By campoProcurar = By.xpath("//li[@class=\"float-action expandable fix-position-bottom opened\"]//input[@placeholder=\"Procurar\"]");
    By resultPesqTipoPratoCafeManha = By.xpath("//div[@data-zh-field-name=\"NMTIPOPRAT\"]//span[text() = 'CAFÉ DA MANHÃ']");
    By resultPesqPratoPaoDeQueijo = By.xpath("//div[@data-zh-field-name=\"NMPRATO\"]//span[text() = 'PÃO DE QUEIJO']");
    By resultPesqCentelaAsiatica = By.xpath("//div[@data-zh-field-name=\"NMPRODUTO\"]//span[text() = 'CENTELLA ASIATICA (FOLHAS)']");
    By resultPesqTipoRetiradaConsumoProducao = By.xpath("//div[@data-zh-field-name=\"NMTIPORETI\"]//span[text() = 'CONSUMO DE PRODUÇÃO']");

    By acaoExbirResumo = By.xpath("//section[@class=\"popup-content\"]//span[text() = 'Exibir Resumo']");
    By acaoExcluirRetirada = By.xpath("//section[@class=\"popup-content\"]//span[text() = 'Excluir Retirada']");
    By acaoAtualizarEstoque = By.xpath("//section[@class=\"popup-content\"]//span[text() = 'Atualizar Estoque']");
    By acaoExibirRomaneio = By.xpath("//section[@class=\"popup-content\"]//span[text() = 'Exibir Romaneio']");

    //componentes da acação exibir romaneio
    By romaneioDataRetDe = By.id("DTRETIRADAINI");
    By romaneioDataRetAte = By.id("DTRETIRADAFIN");
    By romaneioDataCardDe = By.id("DTCARDAPIOINI");
    By romaneioDataCardAte = By.id("DTCARDAPIOFIN");
    By limparRomanDataRetDe = By.xpath("//div[@data-zh-id=\"24939959119517570372769\"]//span[@style=\"background-image: none; display: block;\"]");
    By limparRomanDataRetAte = By.xpath("//div[@data-zh-id=\"2493995915463418302770\"]//span[@style=\"background-image: none; display: block;\"]");
    By limparRomanDataCardDe = By.xpath("//div[@data-zh-id=\"24939959134720090112771\"]//span[@style=\"background-image: none; display: block;\"]");
    By limparRomanDataCardAte = By.xpath("//div[@data-zh-id=\"24939959116485330492772\"]//span[@style=\"background-image: none; display: block;\"]");
    By romanServicoLin1 = By.xpath("//div[@id=\"grid-24939959114454336042751\"]//div[@class=\"body-content\"]/div[1]//div[1]/span");
    By romanNomeLin1 = By.xpath("//div[@id=\"grid-24939959114454336042751\"]//div[@class=\"body-content\"]/div[1]//div[2]/span");
    By romanDataRetLin1 = By.xpath("//div[@id=\"grid-24939959114454336042751\"]//div[@class=\"body-content\"]/div[1]//div[3]/span");
    By romanDataCardLin1 = By.xpath("//div[@id=\"grid-24939959114454336042751\"]//div[@class=\"body-content\"]/div[1]//div[4]/span");
    By romanNumRequisicaoLin1 = By.xpath("//div[@id=\"grid-24939959114454336042751\"]//div[@class=\"body-content\"]/div[1]//div[5]/span");
    By romanNumLnacamentoLin1 = By.xpath("//div[@id=\"grid-24939959114454336042751\"]//div[@class=\"body-content\"]/div[1]//div[6]/span");
    By romanServicoLin2 = By.xpath("//div[@id=\"grid-24939959114454336042751\"]//div[@class=\"body-content\"]/div[2]//div[1]/span");
    By romanNomeLin2 = By.xpath("//div[@id=\"grid-24939959114454336042751\"]//div[@class=\"body-content\"]/div[2]//div[2]/span");
    By romanDataRetLin2 = By.xpath("//div[@id=\"grid-24939959114454336042751\"]//div[@class=\"body-content\"]/div[2]//div[3]/span");
    By romanDataCardLin2 = By.xpath("//div[@id=\"grid-24939959114454336042751\"]//div[@class=\"body-content\"]/div[2]//div[4]/span");
    By romanNumRequisicaoLin2 = By.xpath("//div[@id=\"grid-24939959114454336042751\"]//div[@class=\"body-content\"]/div[2]//div[5]/span");
    By romanNumLnacamentoLin2 = By.xpath("//div[@id=\"grid-24939959114454336042751\"]//div[@class=\"body-content\"]/div[2]//div[6]/span");

    //componentes da tela do formulário de cadastro da retirada
    By campoTipoPrato = By.id("NMTIPOPRAT");
    By tipoPratoArroz = By.xpath("//div[@data-zh-id=\"2493995913344106762829\"]//span[text() = '01 | ARROZ']");
    By tipoPratoFeijao = By.xpath("//div[@data-zh-id=\"2493995913344106762829\"]//span[text() = '05 | FEIJAO']");
    By campoPrato = By.id("NMPRATO");
    By pratoArrozTemperado = By.xpath("//div[@data-zh-id=\"249399591592251592832\"]//span[text() = '00.00.00.000 | ARROZ TEMPEREADO']");
    By pratoFeijoadaSimples = By.xpath("//div[@data-zh-id=\"249399591592251592832\"]//span[text() = '00.00.00.001 | FEIJOADA SIMPLES']");
    By campoProduto = By.id("NMPRODUTO");
    By produtoCreosoto = By.xpath("//div[@data-zh-id=\"24939959129913704632836\"]//span[text() = '1.01.1.1.01.001.00 | CREOSOTO']");
    By produtoOleoCastanha = By.xpath("//div[@data-zh-id=\"24939959129913704632836\"]//span[text() = '1.01.1.1.01.002.00 | OLEO DE CASTANHA DO BRASIL']");
    By produtoOleoCopaiba = By.xpath("//div[@data-zh-id=\"24939959129913704632836\"]//span[text() = '1.01.1.1.01.003.00 | OLEO DE COPAIBA']");
    By produtoOleoAmendoasDoces = By.xpath("//div[@data-zh-id=\"24939959129913704632836\"]//span[text() = '1.01.1.1.01.005.00 | OLEO DE AMENDOAS DOCES']");
    By produtoQuerosene = By.xpath("//div[@data-zh-id=\"24939959129913704632836\"]//span[text() = '1.01.1.1.01.004.00 | QUEROSENE']");
    By produtoCanfora = By.xpath("//div[@data-zh-id=\"24939959129913704632836\"]//span[text() = '1.01.1.1.02.004.00 | CANFORA']");
    By campoQuantExtra = By.id("QTEXTRARETI");
    By campoQuantDevolvida = By.id("QTDEVOLVRETI");
    By campoQuantConsumida = By.id("QTRETIRADA");
    By campoTipoRetirada = By.id("NMTIPORETI");
    By tipoRetiradaConsumoProducao = By.xpath("//div[@data-zh-id=\"24939959115513766182841\"]//span[text() = '01 | CONSUMO DE PRODUÇÃO']");
    By botaoSalvar = By.xpath("//div[@class=\"zh-footer-right\"]");

    By campoAlmoxarifado = By.id("DSALMOXARIFE");
    By almoxarifadoMateriaPrimaAprovado = By.xpath("//div[@data-zh-id=\"0\"]//span[text() = '2 | MATERIA PRIMA APROVADO']");
    By almoxarifadoProdAcabadoAprovado = By.xpath("//div[@data-zh-id=\"0\"]//span[text() = '1 | PRODUTO ACABADO APROVADO']");
    By campoLote = By.id("NRLOTEESTQ");
    By loteCreosoto = By.xpath("//div[@data-zh-id=\"0\"]//span[text() = '22082369 | 31/12/2099 | 9.999,00']");

    By loteOleoCastanha = By.xpath("//div[@data-zh-id=\"0\"]//span[text() = '22082368 | 31/12/2099 | 99.999,00']");
    By loteOleoCastanhaMenosQuant = By.xpath("//div[@data-zh-id=\"0\"]//span[text() = '22082368 | 31/12/2099 | 99.997,00']");
    By loteOleoCastanhaEditInLine = By.xpath("//div[@data-zh-id=\"0\"]//span[text() = '22082368 | 31/12/2099 | 99.995,00']");

    By loteOleoCopaiba = By.xpath("//div[@data-zh-id=\"0\"]//span[text() = '22092082 | 31/12/2099 | 99.999,00']");
    By loteOleoCopaibaMenosQuant = By.xpath("//div[@data-zh-id=\"0\"]//span[text() = '22092082 | 31/12/2099 | 99.996,70']");

    By loteOleaoAmendoasDoces = By.xpath("//div[@data-zh-id=\"0\"]//span[text() = '111 | 31/12/2099 | 9.999,00']");
    By loteOleaoAmendoasDocesMenosQuant = By.xpath("//div[@data-zh-id=\"0\"]//span[text() = '111 | 31/12/2099 | 9.997,00']");
    By loteOleaoAmendoasDocesEditInLine = By.xpath("//div[@data-zh-id=\"0\"]//span[text() = '111 | 31/12/2099 | 9.993,50']");

    By loteQuerosene = By.xpath("//div[@data-zh-id=\"0\"]//span[text() = '200 | 31/12/2099 | 9.999,00']");
    By loteQueroseneMenosQuant = By.xpath("//div[@data-zh-id=\"0\"]//span[text() = '200 | 31/12/2099 | 9.997,50']");

    //componetes da primeira linha de registro da tela inicial do tipo de prato
    By checkBoxLin1 = By.xpath("//div[@id=\"grid-2493995917964005972871\"]//div[@class=\"body-content\"]/div[1]//div[1]/span");
    By tipoPratoLin1 = By.xpath("//div[@id=\"grid-2493995917964005972871\"]//div[@class=\"body-content\"]/div[1]//div[2]/span");
    By nomeLin1 = By.xpath("//div[@id=\"grid-2493995917964005972871\"]//div[@class=\"body-content\"]/div[1]//div[3]/span");
    By codigoPratoLin1 = By.xpath("//div[@id=\"grid-2493995917964005972871\"]//div[@class=\"body-content\"]/div[1]//div[4]/span");
    By nomePratoLin1 = By.xpath("//div[@id=\"grid-2493995917964005972871\"]//div[@class=\"body-content\"]/div[1]//div[5]/span");

    //componetes da segunda linha de registro da tela inicial do tipo de prato
    By checkBoxLin2 = By.xpath("//div[@id=\"grid-2493995917964005972871\"]//div[@class=\"body-content\"]/div[2]//div[1]/span");
    By tipoPratoLin2 = By.xpath("//div[@id=\"grid-2493995917964005972871\"]//div[@class=\"body-content\"]/div[2]//div[2]/span");
    By nomeLin2 = By.xpath("//div[@id=\"grid-2493995917964005972871\"]//div[@class=\"body-content\"]/div[2]//div[3]/span");
    By codigoPratoLin2 = By.xpath("//div[@id=\"grid-2493995917964005972871\"]//div[@class=\"body-content\"]/div[2]//div[4]/span");
    By nomePratoLin2 = By.xpath("//div[@id=\"grid-2493995917964005972871\"]//div[@class=\"body-content\"]/div[2]//div[5]/span");

    //componentes da primeira linha de registro do produto cadastrado no tipo de prato
    By checkBoxProduto = By.xpath("//div[@id=\"grid-24939959122776413062891\"]//div[@class=\"body-content\"]/div[1]//div[1]/span");
    By codigoProduto = By.xpath("//div[@id=\"grid-24939959122776413062891\"]//div[@class=\"body-content\"]/div[1]//div[2]/span");
    By nomeProduto = By.xpath("//div[@id=\"grid-24939959122776413062891\"]//div[@class=\"body-content\"]/div[1]//div[3]/span");
    By unidadeProduto = By.xpath("//div[@id=\"grid-24939959122776413062891\"]//div[@class=\"body-content\"]/div[1]//div[4]/span");
    By quantPrevistaProduto = By.xpath("//div[@id=\"grid-24939959122776413062891\"]//div[@class=\"body-content\"]/div[1]//div[5]/span");
    By quantExtraProduto = By.xpath("//div[@id=\"grid-24939959122776413062891\"]//div[@class=\"body-content\"]/div[1]//div[6]/span");
    By quantDevolvidaProduto = By.xpath("//div[@id=\"grid-24939959122776413062891\"]//div[@class=\"body-content\"]/div[1]//div[7]/span");
    By quantConsumidaProduto = By.xpath("//div[@id=\"grid-24939959122776413062891\"]//div[@class=\"body-content\"]/div[1]//div[8]/span");
    By valorUniTarioProduto = By.xpath("//div[@id=\"grid-24939959122776413062891\"]//div[@class=\"body-content\"]/div[1]//div[9]/span");
    By tipoRetiradaProduto = By.xpath("//div[@id=\"grid-24939959122776413062891\"]//div[@class=\"body-content\"]/div[1]//div[10]/span");
    By statusProduto = By.xpath("//div[@id=\"grid-24939959122776413062891\"]//div[@class=\"body-content\"]/div[1]//div[11]/span");
    By almoxarifadoProduto = By.xpath("//div[@id=\"grid-24939959122776413062891\"]//div[@class=\"body-content\"]/div[1]//div[13]/span");
    By loteProduto = By.xpath("//div[@id=\"grid-24939959122776413062891\"]//div[@class=\"body-content\"]/div[1]//div[15]/span");

    //componente da primeira linha da retira de produto
    By checkBoxProdutoRetProduto = By.xpath("//div[@id=\"grid-2493995912567898485180\"]//div[@class=\"body-content\"]/div[1]//div[1]/span");

    //componente da primeira linha da tela de resumo
    By resumCodigoLin1 = By.xpath("//div[@id=\"grid-24939959133770068892777\"]//div[@class=\"body-content\"]/div[1]//div[1]/span");
    By resumNomeLin1 = By.xpath("//div[@id=\"grid-24939959133770068892777\"]//div[@class=\"body-content\"]/div[1]//div[2]/span");
    By resumUnidadeLin1 = By.xpath("//div[@id=\"grid-24939959133770068892777\"]//div[@class=\"body-content\"]/div[1]//div[3]/span");
    By resumQuantPrevistaLin1 = By.xpath("//div[@id=\"grid-24939959133770068892777\"]//div[@class=\"body-content\"]/div[1]//div[4]/span");
    By resumQuantExtraLin1 = By.xpath("//div[@id=\"grid-24939959133770068892777\"]//div[@class=\"body-content\"]/div[1]//div[5]/span");
    By resumQuantDevolvidaLin1 = By.xpath("//div[@id=\"grid-24939959133770068892777\"]//div[@class=\"body-content\"]/div[1]//div[6]/span");
    By resumQuantConsumidaLin1 = By.xpath("//div[@id=\"grid-24939959133770068892777\"]//div[@class=\"body-content\"]/div[1]//div[7]/span");
    By resumCustoLin1 = By.xpath("//div[@id=\"grid-24939959133770068892777\"]//div[@class=\"body-content\"]/div[1]//div[8]/span");

    //componente da primeira linha da tela de resumo
    By resumCodigoLin2 = By.xpath("//div[@id=\"grid-24939959133770068892777\"]//div[@class=\"body-content\"]/div[2]//div[1]/span");
    By resumNomeLin2 = By.xpath("//div[@id=\"grid-24939959133770068892777\"]//div[@class=\"body-content\"]/div[2]//div[2]/span");
    By resumUnidadeLin2 = By.xpath("//div[@id=\"grid-24939959133770068892777\"]//div[@class=\"body-content\"]/div[2]//div[3]/span");
    By resumQuantPrevistaLin2 = By.xpath("//div[@id=\"grid-24939959133770068892777\"]//div[@class=\"body-content\"]/div[2]//div[4]/span");
    By resumQuantExtraLin2 = By.xpath("//div[@id=\"grid-24939959133770068892777\"]//div[@class=\"body-content\"]/div[2]//div[5]/span");
    By resumQuantDevolvidaLin2 = By.xpath("//div[@id=\"grid-24939959133770068892777\"]//div[@class=\"body-content\"]/div[2]//div[6]/span");
    By resumQuantConsumidaLin2 = By.xpath("//div[@id=\"grid-24939959133770068892777\"]//div[@class=\"body-content\"]/div[2]//div[7]/span");
    By resumCustoLin2 = By.xpath("//div[@id=\"grid-24939959133770068892777\"]//div[@class=\"body-content\"]/div[2]//div[8]/span");

    //nome do produto na primeira linha de registro da tela inicial da retirada produto
    By nomeProdLinha1 = By.xpath("//div[@id=\"grid-2493995912567898485180\"]//div[@class=\"body-content\"]/div[1]//div[3]/span");
    By nomeProdLinha2 = By.xpath("//div[@id=\"grid-2493995912567898485180\"]//div[@class=\"body-content\"]/div[2]//div[3]/span");

    //componentes da tela que é aberta após clicar no nome do produto na tela inicial de retirada do produto
    By campoQuantExtraProd = By.id("QTEXTRARETI");
    By campoQuantDevolvidaProd = By.id("QTDEVOLVRETI");
    By campoQuantConsumidaProd = By.id("QTRETIRADA");

    //campo do log de erro
    By campoLog = By.id("CONTENT");

    //mensagem de que não há registro na tela ações -> exibir resumo
    By mensagemNaoHaRegistroResumo = By.xpath("//div[@id=\"grid-24939959133770068892777\"]//p[@class=\"text-center zh-text-search-not-found ng-binding\"]");

    By quantExtraTelaPrinciapal = By.xpath("//div[@id=\"grid-2493995912567898485180\"]//div[@class=\"body-content\"]/div[1]/div[6]/span");
    By quantDevolvidaTelaPrinciapl = By.xpath("//div[@id=\"grid-2493995912567898485180\"]//div[@class=\"body-content\"]/div[1]/div[7]/span");
    By quantConsumidaTelaPrincipal = By.xpath("//div[@id=\"grid-2493995912567898485180\"]//div[@class=\"body-content\"]/div[1]/div[8]/span");

    By quantExtraTelaProdutoRetTipoPrato = By.xpath("//div[@id=\"grid-24939959122776413062891\"]//div[@class=\"body-content\"]/div[1]/div[6]/span");
    By quantDevolvidaTelaProdutoRetTipoPrato = By.xpath("//div[@id=\"grid-24939959122776413062891\"]//div[@class=\"body-content\"]/div[1]/div[7]/span");
    By quantConsumidaTelaProdutoRetTipoPrato = By.xpath("//div[@id=\"grid-24939959122776413062891\"]//div[@class=\"body-content\"]/div[1]/div[8]/span");

    public void acessarTela() {
        tempoParaAguardarTelaInicial();
        waitForElement(botaoMenu);
        click(botaoMenu);
        sendKeys(campoPesquisar, "Retirada (Planejamento)");
        click(telaRetiradaPlanejamento);
    }

    public void filtroInicial(String dataRetirada, String retirada) {
        if (retirada == "Tipo Prato") {
            clicarCampoSelecionarValor(campoUnidade, unidadeJabaquara);
            clicarCampoSelecionarValor(campoServico, servicoAlmocoEspecial);
        } else if (retirada == "Produto") {
            clicarCampoSelecionarValor(campoUnidade, unidadeBc111);
            clicarCampoSelecionarValor(campoServico, servicoRetiradas);
        }
        click(botaoLimparDataRetirada);
        click(campoDataRetirada);
        sendKeys(campoDataRetirada, dataRetirada);
        click(botaoAplicarFiltro);
    }

    public void alertaNaoExisteRetirada() {
        String mensagemEsperada = "Não existe retirada para os dados informados.\n" +
                "Deseja realizar uma nova retirada?";
        String mensagem = getText(campoMensagemAlerta);
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem de alerta após preencher o primeiro filtro de acesso à tela");
        click(botaoSimAlerta);
    }

    public void confirmarFiltroRetirada() {
        click(botaoConfirmar);
    }

    public void formularioAdicionarTipoPrato() {
        clicarCampoSelecionarValor(campoTipoPrato, tipoPratoFeijao);
        clicarCampoSelecionarValor(campoPrato, pratoFeijoadaSimples);
        clicarCampoSelecionarValor(campoProduto, produtoOleoCastanha);

        clear(campoQuantExtra);
        sendKeys(campoQuantExtra, "4");
        clear(campoQuantDevolvida);
        sendKeys(campoQuantDevolvida, "5");
        click(campoQuantExtra);

        String mensagemAlertaQuant = getText(campoMensagemAlerta);
        String mensagemAlertaQuantEsp = "Quantidade devolvida não pode ser maior que a quantidade requisitada.";
        Assert.assertEquals(mensagemAlertaQuant, mensagemAlertaQuantEsp, "Verificação da mensagem de alerta após tentar adicionar uma quantidade devolvida maior que a extraida");
        click(botaoOkAlerta);

        clear(campoQuantDevolvida);
        sendKeys(campoQuantDevolvida, "2");
        click(campoQuantExtra);

        String quantConsumida = driver.findElement(campoQuantConsumida).getAttribute("value");
        Assert.assertEquals(quantConsumida, "2,00000", "Verificação do valor de quantidade consumida após preencher os campos anteriores");
        click(botaoSalvar);

        clicarCampoSelecionarValor(campoLote, loteOleoCastanha);
        click(botaoConfirmar);

        String mensagemRetiraEsperada = "Retirada incluída com sucesso.";
        String mensagemRetiraEncontrada = getText(campoMensagemAlerta);
        Assert.assertEquals(mensagemRetiraEncontrada, mensagemRetiraEsperada, "Verificação da mensagem exibida na tela após concluir o formulário de retirada do produto");
        click(botaoOkAlerta);
    }

    public void verificarTipoPratoAdicionado() {
        //valores encontrados
        String encTipoPrato = getText(tipoPratoLin1);
        String encNome = getText(nomeLin1);
        String encCodigoPrato = getText(codigoPratoLin1);
        String encNomePrato = getText(nomePratoLin1);

        //valores esperados
        String expTipoPrato = "05";
        String expNome = "FEIJAO";
        String expCodigoPrato = "00.00.00.001";
        String expNomePrato = "FEIJOADA SIMPLES";

        Assert.assertEquals(encTipoPrato, expTipoPrato, "Verificação do valor tipo prato na tela inicial");
        Assert.assertEquals(encNome, expNome, "Verificação do valor nome na tela inicial");
        Assert.assertEquals(encCodigoPrato, expCodigoPrato, "Verificação do valor do código do prato na tela inicial");
        Assert.assertEquals(encNomePrato, expNomePrato, "Verificação do valor nome prato na tela inicial");

        click(nomeLin1);

        //valores encontrados do produto presente na primeira linha
        String encCodigoProduto = getText(codigoProduto);
        String encNomeProduto = getText(nomeProduto);
        String encUnidadeProduto = getText(unidadeProduto);
        String encQuantPrevProduto = getText(quantPrevistaProduto);
        String encQuantExtraProduto = getText(quantExtraProduto);
        String encQuantDevolvidaProduto = getText(quantDevolvidaProduto);
        String encQuantConsumidaProduto = getText(quantConsumidaProduto);
        String encValorUnitarioProduto = getText(valorUniTarioProduto);
        String encTipoRetiradaProduto = getText(tipoRetiradaProduto);
        javaScriptExecutor.executeScript("document.querySelector(\"#grid-24939959122776413062891 > div.body-scroll-control\").scrollBy(900, 0)");
        String encStatusProdutoProduto = getText(statusProduto);
//        tempo();
//        String encAlmoxarifadoProduto = getText(almoxarifadoProduto);
//        tempo();
//        String encLoteProduto = getText(loteProduto);

        //valores esperados do produto presente na primeira linha
        String expCodigoProduto = "1.01.1.1.01.002.00";
        String expNomeProduto = "OLEO DE CASTANHA DO BRASIL";
        String expUnidadeProduto = "L";
        String expQuantPrevProduto = "0,00000";
        String expQuantExtraProduto = "4,00000";
        String expQuantDevolvidaProduto = "2,00000";
        String expQuantConsumidaProduto = "2,00000";
        String expValorUnitarioProduto = "10,00000";
        String expTipoRetiradaProduto = "CONSUMO DE PRODUÇÃO";
        String expStatusProdutoProduto = "Evoluído";
//        String expAlmoxarifadoProduto = "2";
//        String expLoteProduto = "2208236998";

        Assert.assertEquals(encCodigoProduto, expCodigoProduto, "Verificação do código do produto na primeira linha");
        Assert.assertEquals(encNomeProduto, expNomeProduto, "Verificação do nome do produto na primeira linha");
        Assert.assertEquals(encUnidadeProduto, expUnidadeProduto, "Verificação da unidade do produto na primeira linha");
        Assert.assertEquals(encQuantPrevProduto, expQuantPrevProduto, "Verificação da quantidade prevista do produto na primeira linha");
        Assert.assertEquals(encQuantExtraProduto, expQuantExtraProduto, "Verificação da quantidade extra do produto na primeira linha");
        Assert.assertEquals(encQuantDevolvidaProduto, expQuantDevolvidaProduto, "Verificação da quantidade devolvida do produto na primeira linha");
        Assert.assertEquals(encQuantConsumidaProduto, expQuantConsumidaProduto, "Verificação da quantidade consumida do produto na primeira linha");
        Assert.assertEquals(encValorUnitarioProduto, expValorUnitarioProduto, "Verificação do valor unitário do produto na primeira linha");
        Assert.assertEquals(encTipoRetiradaProduto, expTipoRetiradaProduto, "Verificação do tipo de retirada do produto na primeira linha");
        Assert.assertEquals(encStatusProdutoProduto, expStatusProdutoProduto, "Verificação do status do produto na primeira linha");
//        Assert.assertEquals(encAlmoxarifadoProduto, expAlmoxarifadoProduto, "Verificação do almoxarifado do produto na primeira linha");
//        Assert.assertEquals(encLoteProduto, expLoteProduto, "Verificação do lote do produto na primeira linha");
    }

    public void verificarSegundoTipoPratoAdd() {
        //valores encontrados
        String encTipoPrato = getText(tipoPratoLin1);
        String encNome = getText(nomeLin1);
        String encCodigoPrato = getText(codigoPratoLin1);
        String encNomePrato = getText(nomePratoLin1);

        //valores esperados
        String expTipoPrato = "01";
        String expNome = "ARROZ";
        String expCodigoPrato = "00.00.00.000";
        String expNomePrato = "ARROZ TEMPEREADO";

        Assert.assertEquals(encTipoPrato, expTipoPrato, "Verificação do valor do segundo tipo prato adicionado na tela inicial");
        Assert.assertEquals(encNome, expNome, "Verificação do valor nome do segundo tipo prato adicionado na tela inicial");
        Assert.assertEquals(encCodigoPrato, expCodigoPrato, "Verificação do valor do código do prato do segundo tipo prato adicionado na tela inicial");
        Assert.assertEquals(encNomePrato, expNomePrato, "Verificação do valor nome prato do segunda tipo prato adicionado na tela inicial");

        click(nomeLin1);

        //valores encontrados do produto presente na primeira linha
        String encCodigoProduto = getText(codigoProduto);
        String encNomeProduto = getText(nomeProduto);
        String encUnidadeProduto = getText(unidadeProduto);
        String encQuantPrevProduto = getText(quantPrevistaProduto);
        String encQuantExtraProduto = getText(quantExtraProduto);
        String encQuantDevolvidaProduto = getText(quantDevolvidaProduto);
        String encQuantConsumidaProduto = getText(quantConsumidaProduto);
        String encValorUnitarioProduto = getText(valorUniTarioProduto);
        String encTipoRetiradaProduto = getText(tipoRetiradaProduto);
        javaScriptExecutor.executeScript("document.querySelector(\"#grid-24939959122776413062891 > div.body-scroll-control\").scrollBy(900, 0)");
        String encStatusProdutoProduto = getText(statusProduto);

        //valores esperados do produto presente na primeira linha
        String expCodigoProduto = "1.01.1.1.01.003.00";
        String expNomeProduto = "OLEO DE COPAIBA";
        String expUnidadeProduto = "L";
        String expQuantPrevProduto = "0,00000";
        String expQuantExtraProduto = "3,50000";
        String expQuantDevolvidaProduto = "1,20000";
        String expQuantConsumidaProduto = "2,30000";
        String expValorUnitarioProduto = "5,00000";
        String expTipoRetiradaProduto = "CONSUMO DE PRODUÇÃO";
        String expStatusProdutoProduto = "Evoluído";

        Assert.assertEquals(encCodigoProduto, expCodigoProduto, "Verificação do código do produto na primeira linha");
        Assert.assertEquals(encNomeProduto, expNomeProduto, "Verificação do nome do produto na primeira linha");
        Assert.assertEquals(encUnidadeProduto, expUnidadeProduto, "Verificação da unidade do produto na primeira linha");
        Assert.assertEquals(encQuantPrevProduto, expQuantPrevProduto, "Verificação da quantidade prevista do produto na primeira linha");
        Assert.assertEquals(encQuantExtraProduto, expQuantExtraProduto, "Verificação da quantidade extra do produto na primeira linha");
        Assert.assertEquals(encQuantDevolvidaProduto, expQuantDevolvidaProduto, "Verificação da quantidade devolvida do produto na primeira linha");
        Assert.assertEquals(encQuantConsumidaProduto, expQuantConsumidaProduto, "Verificação da quantidade consumida do produto na primeira linha");
        Assert.assertEquals(encValorUnitarioProduto, expValorUnitarioProduto, "Verificação do valor unitário do produto na primeira linha");
        Assert.assertEquals(encTipoRetiradaProduto, expTipoRetiradaProduto, "Verificação do tipo de retirada do produto na primeira linha");
        Assert.assertEquals(encStatusProdutoProduto, expStatusProdutoProduto, "Verificação do status do produto na primeira linha");

        click(botaoVoltar);
    }

    public void adicionarProdutoCreosoto() {
        click(botaoAdicionar);
        clicarCampoSelecionarValor(campoProduto, produtoCreosoto);
        clear(campoQuantExtra);
        sendKeys(campoQuantExtra, "5");
        clear(campoQuantDevolvida);
        sendKeys(campoQuantDevolvida, "4,3");
        click(campoQuantExtra);
        String quantConsumida = driver.findElement(campoQuantConsumida).getAttribute("value");
        Assert.assertEquals(quantConsumida, "0,70000", "Verificação do valor de quantidade consumida após preencher os campos anteriores");
        click(botaoSalvar);

        clicarCampoSelecionarValor(campoLote, loteCreosoto);
        click(botaoConfirmar);
        String mensagemEsperada = "Salvo com sucesso.";
        String mensagem = getText(campoMensagemAlerta);
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem após salvar o tipo prato/produto");
        click(botaoOkAlerta);
    }

    public void editarQuantidadesProd() {
        tempo();
        javaScriptExecutor.executeScript("document.querySelector(\"#grid-24939959122776413062891 > div.body-scroll-control\").scrollBy(-650, 0)");
        click(nomeProduto);
        Actions actions = new Actions(driver);
        WebElement elementQuantExtra = driver.findElement(campoQuantExtra);
        actions.moveToElement(driver.findElement(campoQuantExtra)).doubleClick().build().perform();
        sendKeys(campoQuantExtra, "5");

        actions.moveToElement(driver.findElement(campoQuantDevolvida)).doubleClick().build().perform();
        sendKeys(campoQuantDevolvida, "1,5");

        actions.moveToElement(elementQuantExtra).click().build().perform();
        String quantConsumida = driver.findElement(campoQuantConsumida).getAttribute("value");
        Assert.assertEquals(quantConsumida, "3,50000", "Verificação do valor de quantidade consumida após editar os campos anteriores");
        click(botaoSalvar);

        clicarCampoSelecionarValor(campoLote, loteOleoCastanhaMenosQuant);
        click(botaoConfirmar);

        String mensagem = getText(campoMensagemAlerta);
        String mensagemEsperada = "Salvo com sucesso.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem exibida após editar as quatidades do produto");
        click(botaoOkAlerta);
    }

    public void editarQuantExtraTelaProdutoRetTipoPrato() {
        tempo();
        Actions actions = new Actions(driver);
        actions.moveToElement(driver.findElement(quantExtraTelaProdutoRetTipoPrato)).click().build().perform();
        tempo();
        actions.sendKeys(Keys.BACK_SPACE).build().perform();
        tempo();
        actions.sendKeys("6").build().perform();
        tempo();
        actions.sendKeys(Keys.ENTER).build().perform();

        clicarCampoSelecionarValor(campoLote, loteOleoCastanhaMenosQuant);
        click(botaoConfirmar);
        String mensagemEsperada = "Salvo com sucesso.";
        String mensagem = getText(campoMensagemAlerta);
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem após salvar o tipo prato/produto");
        click(botaoOkAlerta);
    }

    public void editarQuantConsumidaProdutoRetTipoPrato() {
        tempo();
        Actions actions = new Actions(driver);
        actions.moveToElement(driver.findElement(quantConsumidaTelaProdutoRetTipoPrato)).click().build().perform();
        tempo();
        actions.sendKeys(Keys.BACK_SPACE).build().perform();
        tempo();
        actions.sendKeys("2,7").build().perform();
        tempo();
        actions.sendKeys(Keys.ENTER).build().perform();

        clicarCampoSelecionarValor(campoLote, loteOleoCastanhaEditInLine);
        click(botaoConfirmar);
        String mensagemEsperada = "Salvo com sucesso.";
        String mensagem = getText(campoMensagemAlerta);
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem após salvar o tipo prato/produto");
        click(botaoOkAlerta);
    }

    public void verificarValEdicaoQuantProdRetTipoPrato(String aposEdicao) {
        tempo();
        //valores encontrados
        String encQuantExtra = getText(quantExtraTelaProdutoRetTipoPrato);
        String encQuantDevolvida = getText(quantDevolvidaTelaProdutoRetTipoPrato);
        String encQuantConsumida = getText(quantConsumidaTelaProdutoRetTipoPrato);

        String expQuantExtra = "";
        String expQuantConsumida = "";
        String expQuantDevolvida = "";

        //valores encontrados
        if (aposEdicao == "Quantidade Extra") {
            expQuantExtra = "6,00000";
            expQuantDevolvida = "2,00000";
            expQuantConsumida = "4,00000";
        } else if (aposEdicao == "Quantidade Consumida") {
            expQuantExtra = "2,70000";
            expQuantDevolvida = "0,00000";
            expQuantConsumida = "2,70000";
        }

        Assert.assertEquals(encQuantExtra, expQuantExtra, "Varificação do valor da quantidade extra, após a edição da " + aposEdicao + " ser feita na tela inicial");
        Assert.assertEquals(encQuantDevolvida, expQuantDevolvida, "Varificação do valor da quantidade devolvida, após a edição da " + aposEdicao + " ser feita na tela inicial");
        Assert.assertEquals(encQuantConsumida, expQuantConsumida, "Varificação do valor da quantidade consumida, após a edição da " + aposEdicao + " ser feita na tela inicial");
    }

    public void excluirProduto() {
        click(checkBoxProduto);
        click(botaoExcluir);
        String mensagemEsperada = "Deletar o(s) registro(s)?";
        String mensagem = getText(campoMensagemAlerta);
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem de alerta após tentar excluir o produto");
        click(botaoSimAlerta);

        mensagemEsperada = "Produto(s) excluído(s) com sucesso.";
        mensagem = getText(campoMensagemAlerta);
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem de sucesso após excluir o produto");
        click(botaoOkAlerta);
    }

    public void verificarProdutoAdicionado() {
        javaScriptExecutor.executeScript("document.querySelector(\"#grid-24939959122776413062891 > div.body-scroll-control\").scrollBy(-900, 0)");

        //valores encontrados do produto presente na primeira linha
        String encCodigoProduto = getText(codigoProduto);
        String encNomeProduto = getText(nomeProduto);
        String encUnidadeProduto = getText(unidadeProduto);
        String encQuantPrevProduto = getText(quantPrevistaProduto);
        String encQuantExtraProduto = getText(quantExtraProduto);
        String encQuantDevolvidaProduto = getText(quantDevolvidaProduto);
        String encQuantConsumidaProduto = getText(quantConsumidaProduto);
        String encValorUnitarioProduto = getText(valorUniTarioProduto);
        String encTipoRetiradaProduto = getText(tipoRetiradaProduto);
        javaScriptExecutor.executeScript("document.querySelector(\"#grid-24939959122776413062891 > div.body-scroll-control\").scrollBy(900, 0)");
        String encStatusProdutoProduto = getText(statusProduto);
//        String encAlmoxarifadoProduto = getText(almoxarifadoProduto);
//        String encLoteProduto = getText(loteProduto);

        //valores esperados do produto presente na primeira linha
        String expCodigoProduto = "1.01.1.1.01.001.00";
        String expNomeProduto = "CREOSOTO";
        String expUnidadeProduto = "L";
        String expQuantPrevProduto = "0,00000";
        String expQuantExtraProduto = "5,00000";
        String expQuantDevolvidaProduto = "4,30000";
        String expQuantConsumidaProduto = "0,70000";
        String expValorUnitarioProduto = "5,00000";
        String expTipoRetiradaProduto = "CONSUMO DE PRODUÇÃO";
        String expStatusProdutoProduto = "Evoluído";
//        String expAlmoxarifadoProduto = "2";
//        String expLoteProduto = "2208236998";

        Assert.assertEquals(encCodigoProduto, expCodigoProduto, "Verificação do código do produto adicionado");
        Assert.assertEquals(encNomeProduto, expNomeProduto, "Verificação do nome do produto adicionado");
        Assert.assertEquals(encUnidadeProduto, expUnidadeProduto, "Verificação da unidade do produto adicionado");
        Assert.assertEquals(encQuantPrevProduto, expQuantPrevProduto, "Verificação da quantidade prevista do produto adicionado");
        Assert.assertEquals(encQuantExtraProduto, expQuantExtraProduto, "Verificação da quantidade extra do produto adicionado");
        Assert.assertEquals(encQuantDevolvidaProduto, expQuantDevolvidaProduto, "Verificação da quantidade devolvida do produto adicionado");
        Assert.assertEquals(encQuantConsumidaProduto, expQuantConsumidaProduto, "Verificação da quantidade consumida do produto adicionado");
        Assert.assertEquals(encValorUnitarioProduto, expValorUnitarioProduto, "Verificação do valor unitário do produto adicionado");
        Assert.assertEquals(encTipoRetiradaProduto, expTipoRetiradaProduto, "Verificação do tipo de retirada do produto adicionado");
        Assert.assertEquals(encStatusProdutoProduto, expStatusProdutoProduto, "Verificação do status do produto adicionado");
//        Assert.assertEquals(encAlmoxarifadoProduto, expAlmoxarifadoProduto, "Verificação do almoxarifado do produto na primeira linha");
//        Assert.assertEquals(encLoteProduto, expLoteProduto, "Verificação do lote do produto na primeira linha");

        click(botaoVoltar);
    }

    public void excluirTipoPrato() {
        click(checkBoxLin1);
        click(botaoExcluir);
        String mensagemEsperada = "Deletar o(s) registro(s)?";
        String mensagem = getText(campoMensagemAlerta);
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem de alerta após tentar excluir o tipo de prato");
        click(botaoSimAlerta);

        mensagemEsperada = "Prato(s) excluído(s) com sucesso.";
        mensagem = getText(campoMensagemAlerta);
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem sucesso após excluir a retirada");
        click(botaoOkAlerta);
    }

    public void adicionarSegundoTipoPrato(String mensagemEsperada) {
        tempo();
        click(botaoAdicionar);
        clicarCampoSelecionarValor(campoTipoPrato, tipoPratoArroz);
        clicarCampoSelecionarValor(campoPrato, pratoArrozTemperado);

        clicarCampoSelecionarValor(campoProduto, produtoOleoCopaiba);
        clear(campoQuantExtra);
        sendKeys(campoQuantExtra, "3,5");
        clear(campoQuantDevolvida);
        sendKeys(campoQuantDevolvida, "1,2");
        click(campoQuantExtra);

        String quantConsumida = driver.findElement(campoQuantConsumida).getAttribute("value");
        Assert.assertEquals(quantConsumida, "2,30000", "Verificação do valor de quantidade consumida após preencher os campos anteriores");
        click(botaoSalvar);

        if (mensagemEsperada == "Salvo com sucesso.") clicarCampoSelecionarValor(campoLote, loteOleoCopaiba);
        else if (mensagemEsperada == "Já existe item cadastrado.") clicarCampoSelecionarValor(campoLote, loteOleoCopaibaMenosQuant);

        click(botaoConfirmar);
        String mensagem = getText(campoMensagemAlerta);
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem após salvar o segundo tipo de prato");
        click(botaoOkAlerta);
    }

    public void verificarResumo() {
        tempo();
        click(botaoAcoes);
        click(acaoExbirResumo);

        //valores encontrados na primeira linha
        String encCodigo = getText(resumCodigoLin1);
        String encNome = getText(resumNomeLin1);
        String encUnidade = getText(resumUnidadeLin1);
        String encQuantPrevista = getText(resumQuantPrevistaLin1);
        String encQuantExtra = getText(resumQuantExtraLin1);
        String encQuantDevolvida = getText(resumQuantDevolvidaLin1);
        String encQuantConsumida = getText(resumQuantConsumidaLin1);
        String encCusto = getText(resumCustoLin1);

        //valores esperados na primeira linha
        String expCodigo = "1.01.1.1.01.001.00";
        String expNome = "CREOSOTO";
        String expUnidade = "L";
        String expQuantPrevista = "0,00000";
        String expQuantExtra = "5,00000";
        String expQuantDevolvida = "4,30000";
        String expQuantConsumida = "0,70000";
        String expCusto = "7,27276";

        Assert.assertEquals(encCodigo, expCodigo, "Verificação do código da primeira linha do resumo");
        Assert.assertEquals(encNome, expNome, "Verificação do nome da primeira linha do resumo");
        Assert.assertEquals(encUnidade, expUnidade, "Verificação da unidade da primeira linha do resumo");
        Assert.assertEquals(encQuantPrevista, expQuantPrevista, "Verificação da quantidade prevista da primeira linha do resumo");
        Assert.assertEquals(encQuantExtra, expQuantExtra, "Verificação da quantidade extra da primeira linha do resumo");
        Assert.assertEquals(encQuantDevolvida, expQuantDevolvida, "Verificação da quantidade devolvida da primeira linha do resumo");
        Assert.assertEquals(encQuantConsumida, expQuantConsumida, "Verificação da quantidade consumida da primeira linha do resumo");
        Assert.assertEquals(encCusto, expCusto, "Verificação do custo da primeira linha do resumo");

        //valores encontrados na segunda linha
        encCodigo = getText(resumCodigoLin2);
        encNome = getText(resumNomeLin2);
        encUnidade = getText(resumUnidadeLin2);
        encQuantPrevista = getText(resumQuantPrevistaLin2);
        encQuantExtra = getText(resumQuantExtraLin2);
        encQuantDevolvida = getText(resumQuantDevolvidaLin2);
        encQuantConsumida = getText(resumQuantConsumidaLin2);
        encCusto = getText(resumCustoLin2);

        //valores esperados na segunda linha
        expCodigo = "1.01.1.1.01.003.00";
        expNome = "OLEO DE COPAIBA";
        expUnidade = "L";
        expQuantPrevista = "0,00000";
        expQuantExtra = "3,50000";
        expQuantDevolvida = "1,20000";
        expQuantConsumida = "2,30000";
        expCusto = "5,00000";

        Assert.assertEquals(encCodigo, expCodigo, "Verificação do código da segunda linha do resumo");
        Assert.assertEquals(encNome, expNome, "Verificação do nome da segunda linha do resumo");
        Assert.assertEquals(encUnidade, expUnidade, "Verificação da unidade da segunda linha do resumo");
        Assert.assertEquals(encQuantPrevista, expQuantPrevista, "Verificação da quantidade prevista da segunda linha do resumo");
        Assert.assertEquals(encQuantExtra, expQuantExtra, "Verificação da quantidade extra da segunda linha do resumo");
        Assert.assertEquals(encQuantDevolvida, expQuantDevolvida, "Verificação da quantidade devolvida da segunda linha do resumo");
        Assert.assertEquals(encQuantConsumida, expQuantConsumida, "Verificação da quantidade consumida da segunda linha do resumo");
        Assert.assertEquals(encCusto, expCusto, "Verificação do custo da segunda linha do resumo");

        click(botaoVoltarAcoes);
    }

    public void verificarAcaoExibirRomaneio(String retirada) {
        tempo();
        click(botaoAcoes);
        click(acaoExibirRomaneio);
        preencherDataRomaneio(limparRomanDataRetDe, romaneioDataRetDe, "01/08/2022");
        preencherDataRomaneio(limparRomanDataRetAte, romaneioDataRetAte, "30/09/2022");
        preencherDataRomaneio(limparRomanDataCardDe, romaneioDataCardDe, "01/08/2022");
        preencherDataRomaneio(limparRomanDataCardAte, romaneioDataCardAte, "30/09/2022");
        click(botaoAplicarFiltro);

        //valores encontrados na linha 1
        String encServico = getText(romanServicoLin1);
        String encNome = getText(romanNomeLin1);
        String encDataRet = getText(romanDataRetLin1);
        String encDataCard = getText(romanDataCardLin1);
        String encNumRequi = getText(romanNumRequisicaoLin1);
        String encNumLancamento = getText(romanNumLnacamentoLin1);

        //valores esperados na linha 1
        String expServico = "";
        String expNome = "";
        String expDataRet = "";
        String expDataCard = "";
        String expNumRequi = "";
        String expNumLancamento = "";

        if (retirada == "Tipo Prato") {
            expServico = "00002";
            expNome = "ALMOÇO ESPECIAL";
            expDataRet = "28/08/2022";
            expDataCard = "28/08/2022";
            expNumRequi = "0000000000";
            expNumLancamento = "0000119762";
        } else if (retirada == "Produto") {
            expServico = "00001";
            expNome = "RETIRADAS";
            expDataRet = "02/09/2022";
            expDataCard = "02/09/2022";
            expNumRequi = "0000000000";
            expNumLancamento = "0000119772";
        }

        Assert.assertEquals(encServico, expServico, "Verificação da coluna serviço na linha 1");
        Assert.assertEquals(encNome, expNome, "Verificação da coluna nome na linha 1");
        Assert.assertEquals(encDataRet, expDataRet, "Verificação da coluna data retirada na linha 1");
        Assert.assertEquals(encDataCard, expDataCard, "Verificação da coluna data cardápio na linha 1");
        Assert.assertEquals(encNumRequi, expNumRequi, "Verificação da coluna número requisição na linha 1");
        Assert.assertEquals(encNumLancamento, expNumLancamento, "Verificação da coluna número lançamento na linha 1");

        //valores encontrados na linha 2
        encServico = getText(romanServicoLin2);
        encNome = getText(romanNomeLin2);
        encDataRet = getText(romanDataRetLin2);
        encDataCard = getText(romanDataCardLin2);
        encNumRequi = getText(romanNumRequisicaoLin2);
        encNumLancamento = getText(romanNumLnacamentoLin2);

        //valores esperados para a segunda linha
        if (retirada == "Tipo Prato") {
            expServico = "00002";
            expNome = "ALMOÇO ESPECIAL";
            expDataRet = "30/08/2022";
            expDataCard = "30/08/2022";
            expNumRequi = "0000000000";
            expNumLancamento = "0000119749";
        } else if (retirada == "Produto") {
            expServico = "00001";
            expNome = "RETIRADAS";
            expDataRet = "15/09/2022";
            expDataCard = "15/09/2022";
            expNumRequi = "0000000000";
            expNumLancamento = "0000119779";
        }

        Assert.assertEquals(encServico, expServico, "Verificação da coluna serviço na linha 2");
        Assert.assertEquals(encNome, expNome, "Verificação da coluna nome na linha 2");
        Assert.assertEquals(encDataRet, expDataRet, "Verificação da coluna data retirada na linha 2");
        Assert.assertEquals(encDataCard, expDataCard, "Verificação da coluna data cardápio na linha 2");
        Assert.assertEquals(encNumRequi, expNumRequi, "Verificação da coluna número requisição na linha 2");
        Assert.assertEquals(encNumLancamento, expNumLancamento, "Verificação da coluna número lançamento na linha 2");

        click(botaoVoltarAcoes);
        tempo();
        click(botaoCancelarPopupContainer);
    }

    private void preencherDataRomaneio(By botaoLimpar, By campo, String valor) {
        click(botaoLimpar);
        click(campo);
        sendKeys(campo, valor);
    }

    public void excluirRetirada() {
        tempo();
        click(botaoAcoes);
        click(acaoExcluirRetirada);

        String mensagemEsperada = "Deseja realmente excluir a retirada?";
        String mensagem = getText(campoMensagemAlerta);
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem de alerta exbidada na tela após clicar na ação de excluir retirada");
        tempo();
        click(botaoSimAlerta);

        mensagemEsperada = "Retirada excluída com sucesso.";
        mensagem = getText(campoMensagemAlerta);
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem de sucesso após excluir a retirada");
        click(botaoOkAlerta);
    }

    public void atualizarEstoque() {
        tempo();
        click(botaoAcoes);
        click(acaoAtualizarEstoque);

        String mensagem = getText(campoMensagemAlerta);
        String mensagemEsperada = "Estoque atualizado com sucesso.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem exibida na tela após executar a ação de atualizar o estoque");
        click(botaoOkAlerta);
    }

    public void excluirRetiradaProduto() {
        click(checkBoxProdutoRetProduto);
        click(botaoExcluir);
        String mensagemEsperada = "Deletar o(s) registro(s)?";
        String mensagem = getText(campoMensagemAlerta);
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem de alerta após tentar excluir o produto");
        click(botaoSimAlerta);

        mensagemEsperada = "Produto(s) excluído(s) com sucesso.";
        mensagem = getText(campoMensagemAlerta);
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem de sucesso após excluir o produto");
        click(botaoOkAlerta);
    }

    public void atualizarEstoqueIrregular() {
        tempo();
        click(botaoAcoes);
        click(acaoAtualizarEstoque);

        String mensagem = getText(campoMensagemAlerta);
        String mensagemEsperada = "A confirmação da operação faria com que a posição de estoque de alguns itens se tornasse irregular.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem exibida na tela após executar a ação de atualizar o estoque");
        click(botaoOkAlerta);
        click(botaoCancelarPopupContainer);
    }

    public void exibirResumoRetiradaProduto() {
        click(botaoAcoes);
        click(acaoExbirResumo);

        //valores encontrados
        String encCodigo = getText(resumCodigoLin1);
        String encNome = getText(resumNomeLin1);
        String encUnidade = getText(resumUnidadeLin1);
        String encQuantPrevista = getText(resumQuantPrevistaLin1);
        String encQuantExtra = getText(resumQuantExtraLin1);
        String encQuantDevolvida = getText(resumQuantDevolvidaLin1);
        String encQuantConsumida = getText(resumQuantConsumidaLin1);
        String encCusto = getText(resumCustoLin1);

        //valores esperados na primeira linha
        String expCodigo = "1.01.1.1.01.004.00";
        String expNome = "QUEROSENE";
        String expUnidade = "L";
        String expQuantPrevista = "0,00000";
        String expQuantExtra = "5,00000";
        String expQuantDevolvida = "4,00000";
        String expQuantConsumida = "1,00000";
        String expCusto = "7,00000";

        Assert.assertEquals(encCodigo, expCodigo, "Verificação do código no resumo");
        Assert.assertEquals(encNome, expNome, "Verificação do nome no resumo");
        Assert.assertEquals(encUnidade, expUnidade, "Verificação da unidade no resumo");
        Assert.assertEquals(encQuantPrevista, expQuantPrevista, "Verificação da quantidade prevista no resumo");
        Assert.assertEquals(encQuantExtra, expQuantExtra, "Verificação da quantidade extra no resumo");
        Assert.assertEquals(encQuantDevolvida, expQuantDevolvida, "Verificação da quantidade devolvida no resumo");
        Assert.assertEquals(encQuantConsumida, expQuantConsumida, "Verificação da quantidade consumida no resumo");
        Assert.assertEquals(encCusto, expCusto, "Verificação do custo no resumo");

        click(botaoVoltar);
    }

    public void limparCamposApliFiltroIni() {
        click(botaoLimparUnidade);
        click(botaoLimparDataRetirada);
        click(botaoAplicarFiltro);
    }

    public void verificarMensObrigaFiltroIni() {
        String unidade = getText(mensagemObrigatorioUnidadeIni);
        String servico = getText(mensagemObrigatorioServicoIni);
        String dataRetirada = getText(mensagemObrigatorioDataRetiradaIni);
        String dataCardapio = getText(mensagemObrigatorioDataCardapioIni);

        String mensagemEsperada = "Campo obrigatório";
        Assert.assertEquals(unidade, mensagemEsperada, "Verificação da mensagem de obrigatório do campo unidade do filtro inicial");
        Assert.assertEquals(servico, mensagemEsperada, "Verificação da mensagem de obrigatório do campo serviço do filtro inicial");
        Assert.assertEquals(dataRetirada, mensagemEsperada, "Verificação da mensagem de obrigatório do campo data retirada do filtro inicial");
        Assert.assertEquals(dataCardapio, mensagemEsperada, "Verificação da mensagem de obrigatório do campo data cardápio do filtro inicial");
    }

    public void filtroIniDataInvalida(String data, String retirada) {
        tempo();
        filtroInicial(data, retirada);
        alertaNaoExisteRetirada();
        confirmarFiltroRetirada();
        tempo();

        String mensagemEsperada = "Ocorreram alguns erros durante esta operação Data informada não deve ser maior que a data de processamento.";
        String mensagem = getText(campoMensagemAlerta);
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem de após após inserir uma data futura e confirmar no filtro nova retirada");
        click(botaoOkAlerta);

        //verificar data retirada encontrada no campo, após preencher com uma data inválida
        String encDataRetirada = driver.findElement(campoDataRetirada).getAttribute("value");
        String expDataRetirada = "30/12/3200";

        Assert.assertEquals(encDataRetirada, expDataRetirada, "Verificação do valor do campo de data retirada, após o preencimento de uma data inválida");
    }

    public void verificarMensObrigaFilNovaRetirada(String data, String retirada) {
        filtroInicial(data, retirada);
        alertaNaoExisteRetirada();
        click(botaoLimparNumRequisicao);
        confirmarFiltroRetirada();
        tempo();

        String servico = getText(mensagemObrigatorioServicoNovaRetirada);
        String numeroRequisicao = getText(mensagemObrigatorioNumRequisicaoNovaRetirada);
        String dataRetirada = getText(mensagemObrigatorioDataRetiradaNovaRetirada);
        String dataCardapio = getText(mensagemObrigatorioDataCardapioNovaRetirada);

        String mensagemEsperada = "Campo obrigatório";

        Assert.assertEquals(servico, mensagemEsperada, "Verificação da mensagem de campo obrigatório do campo serviço no filtro nova retirada");
        Assert.assertEquals(numeroRequisicao, mensagemEsperada, "Verificação da mensagem de campo obrigatório do campo número requisição no filtro nova retirada");
        Assert.assertEquals(dataRetirada, mensagemEsperada, "Verificação da mensagem de campo obrigatório do campo data retirada no filtro nova retirada");
        Assert.assertEquals(dataCardapio, mensagemEsperada, "Verificação da mensagem de campo obrigatório do campo data retirada no filtro nova retirada");
    }

    public void camposObrigatoriosAddRetirada() {
        tempo();
        click(campoQuantExtra);
        click(campoQuantDevolvida);
        click(campoQuantConsumida);
        click(botaoLimparTipoRetirada);
        click(botaoSalvar);

        //mensagem de campo obrigatório encontrado nos campos
        String tipoPrato = getText(mensagemObrigatorioTipoPrato);
        String prato = getText(mensagemObrigatorioPrato);
        String produto = getText(mensagemObrigatorioProduto);
        String quantExtra = getText(mensagemObrigatorioQuantExtra);
        String quantDevolvida = getText(mensagemObrigatorioQuantDevolvida);
        String quantConsumida = getText(mensagemObrigatorioQuantConsumida);
        String tipoRetirada = getText(mensagemObrigatorioTipoRetirada);

        String mensagemEsperada = "Campo obrigatório";

        Assert.assertEquals(tipoPrato, mensagemEsperada,"Verificação da mensagem de campo obrigatório no campo 'tipo prato', após tentar adicionar retirada com o campo vazio");
        Assert.assertEquals(prato, mensagemEsperada,"Verificação da mensagem de campo obrigatório no campo 'prato' após tentar adicionar retirada com o campo vazio");
        Assert.assertEquals(produto, mensagemEsperada, "Verificação da mensagem de campo obrigatório no campo 'produto', após tentar adicionar retirada com o campo vazio");
        Assert.assertEquals(quantExtra, mensagemEsperada, "Verificação da mensagem de campo obrigatório no campo 'quantidade extra', após tentar adicionar retirada com o campo vazio");
        Assert.assertEquals(quantDevolvida, mensagemEsperada, "Verificação da mensagem de campo obrigatório no campo 'quantidade devolvida', após tentar adicionar retirada com o campo vazio");
        Assert.assertEquals(quantConsumida, mensagemEsperada, "Verificação da mensagem de campo obrigatório no campo 'quantidade consumida', após tentar adicionar retirada com o campo vazio");
        Assert.assertEquals(tipoRetirada, mensagemEsperada, "Verificação da mensagem de campo obrigatório no campo 'tipo de retirada', após tentar adicionar retirada com o campo vazio");

        Actions actions = new Actions(driver);
        actions.moveToElement(driver.findElement(campoTipoPrato), -200, 0).click().build().perform();
        click(tipoPratoFeijao);

        actions.moveToElement(driver.findElement(campoPrato), -200, 0).click().build().perform();
        click(pratoFeijoadaSimples);

        actions.moveToElement(driver.findElement(campoProduto), -200, 0).click().build().perform();
        click(produtoOleoCastanha);

        actions.moveToElement(driver.findElement(campoTipoRetirada), -200, 0).click().build().perform();
        click(tipoRetiradaConsumoProducao);

        sendKeys(campoQuantExtra, "4");
        sendKeys(campoQuantDevolvida, "2");
        click(botaoSalvar);
        click(botaoLimparAlmoxarifado);
        click(botaoConfirmar);

        String mensagemAlmoxarifado = getText(mensagemObrigatorioAlmoxarifado);
        String mensagemLote = getText(mensagemObrigatorioLote);
        Assert.assertEquals(mensagemAlmoxarifado, mensagemEsperada, "Verificação da mensagem de campo obrigatório no campo 'almoxarifado', após tentar confirmar com o campo vazio");
        Assert.assertEquals(mensagemLote, mensagemEsperada, "Verificação da mensagem de campo obrigatório no campo 'lote', após tentar confirmar com o campo vazio");

        actions.moveToElement(driver.findElement(campoAlmoxarifado), -200, 0).click().build().perform();
        click(almoxarifadoMateriaPrimaAprovado);

        tempo();
        actions.moveToElement(driver.findElement(campoLote), -200, 0).click().build().perform();
        click(loteOleoCastanha);
        click(botaoConfirmar);

        String mensagemRetiraEsperada = "Retirada incluída com sucesso.";
        String mensagemRetiraEncontrada = getText(campoMensagemAlerta);
        Assert.assertEquals(mensagemRetiraEncontrada, mensagemRetiraEsperada, "Verificação da mensagem exibida na tela após concluir o formulário de retirada do produto");
        click(botaoOkAlerta);
    }

    public void produtoComCamposVazios() {
        tempo();
        click(nomeLin1);
        tempo();
        click(botaoAdicionar);
        click(campoQuantExtra);
        click(campoQuantDevolvida);
        click(campoQuantConsumida);
        click(botaoLimparTipoRetirada);
        click(botaoSalvar);

        String produtoOb = getText(mensagemObrigatorioProduto);
        String quantExtraOb = getText(mensagemObrigatorioQuantExtra);
        String quantDevolvidaOb = getText(mensagemObrigatorioQuantDevolvida);
        String quantConsumidaOb = getText(mensagemObrigatorioQuantConsumida);
        String tipoRetiradaOb = getText(mensagemObrigatorioTipoRetirada);

        String mensagemEsperada = "Campo obrigatório";
        Assert.assertEquals(produtoOb, mensagemEsperada, "Verificação da mensagem de campo obrigatório, do campo 'produto', após tentar adicionar um produto com os campo vazios");
        Assert.assertEquals(quantExtraOb, mensagemEsperada,"Verificação da mensagem de campo obrigatório, do campo 'quantidade extra', após tentar adicionar um produto com os campo vazios");
        Assert.assertEquals(quantDevolvidaOb, mensagemEsperada, "Verificação da mensagem de campo obrigatório, do campo 'quantidade devolvida', após tentar adicionar um produto com os campo vazios");
        Assert.assertEquals(quantConsumidaOb, mensagemEsperada, "Verificação da mensagem de campo obrigatório, do campo 'quantidade consumida', após tentar adicionar um produto com os campo vazios");
        Assert.assertEquals(tipoRetiradaOb, mensagemEsperada, "Verificação da mensagem de campo obrigatório, do campo 'tipo de retirada', após tentar adicionar um produto com os campo vazios");

        Actions actions = new Actions(driver);
        actions.moveToElement(driver.findElement(campoProduto), -200, 0).click().build().perform();
        click(produtoCreosoto);

        actions.moveToElement(driver.findElement(campoTipoRetirada), -200, 0).click().build().perform();
        click(tipoRetiradaConsumoProducao);

        sendKeys(campoQuantExtra, "5");
        sendKeys(campoQuantDevolvida, "4,3");
        click(campoQuantExtra);
        String quantConsumida = driver.findElement(campoQuantConsumida).getAttribute("value");
        Assert.assertEquals(quantConsumida, "0,70000", "Verificação do valor de quantidade consumida após preencher os campos anteriores");
        click(botaoSalvar);
        click(botaoLimparAlmoxarifado);
        click(botaoConfirmar);

        mensagemEsperada = "Campo obrigatório";
        String mensagemAlmoxarifado = getText(mensagemObrigatorioAlmoxarifado);
        String mensagemLote = getText(mensagemObrigatorioLote);
        Assert.assertEquals(mensagemAlmoxarifado, mensagemEsperada, "Verificação da mensagem de campo obrigatório no campo 'almoxarifado', após tentar confirmar com o campo vazio");
        Assert.assertEquals(mensagemLote, mensagemEsperada, "Verificação da mensagem de campo obrigatório no campo 'lote', após tentar confirmar com o campo vazio");

        actions.moveToElement(driver.findElement(campoAlmoxarifado), -200, 0).click().build().perform();
        click(almoxarifadoMateriaPrimaAprovado);

        tempo();
        actions.moveToElement(driver.findElement(campoLote), -200, 0).click().build().perform();
        click(loteCreosoto);
        click(botaoConfirmar);

        mensagemEsperada = "Salvo com sucesso.";
        String mensagem = getText(campoMensagemAlerta);
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem após salvar o tipo prato/produto");
        click(botaoOkAlerta);
    }

    public void formularioAdicionarRetProduto(String mensagemRetiraEsperada) {
        clicarCampoSelecionarValor(campoProduto, produtoOleoAmendoasDoces);
        clear(campoQuantExtra);
        sendKeys(campoQuantExtra, "4");
        clear(campoQuantDevolvida);
        sendKeys(campoQuantDevolvida, "5");
        click(campoQuantExtra);

        String mensagemAlertaQuant = getText(campoMensagemAlerta);
        String mensagemAlertaQuantEsp = "Quantidade devolvida não pode ser maior que a quantidade requisitada.";
        Assert.assertEquals(mensagemAlertaQuant, mensagemAlertaQuantEsp, "Verificação da mensagem de alerta após tentar adicionar uma quantidade devolvida maior que a extraida");
        click(botaoOkAlerta);

        clear(campoQuantDevolvida);
        sendKeys(campoQuantDevolvida, "2");
        click(campoQuantExtra);
        String quantConsumida = driver.findElement(campoQuantConsumida).getAttribute("value");
        Assert.assertEquals(quantConsumida, "2,00000", "Verificação do valor de quantidade consumida após preencher os campos anteriores");
        click(botaoSalvar);

        clicarCampoSelecionarValor(campoAlmoxarifado, almoxarifadoProdAcabadoAprovado);
        clicarCampoSelecionarValor(campoLote, loteOleaoAmendoasDoces);
        click(botaoConfirmar);

        String mensagemRetiraEncontrada = getText(campoMensagemAlerta);
        Assert.assertEquals(mensagemRetiraEncontrada, mensagemRetiraEsperada, "Verificação da mensagem exibida na tela após concluir o formulário de retirada do produto");
        click(botaoOkAlerta);
    }

    public void erroLog() {
        tempo();
        String mensagemLog = driver.findElement(campoLog).getAttribute("value");
        String mensagemEsperada = "A confirmação da operação faria com que a posição de estoque de alguns itens se tornasse irregular.\n";
        Assert.assertEquals(mensagemLog, mensagemEsperada);
        click(botaoCancelarPopupContainer);
    }

    public void addSegundaRetiradaProduto(String mensagemRetiraEsperada) {
        tempo();
        click(botaoAdicionar);
        clicarCampoSelecionarValor(campoProduto, produtoQuerosene);
        clear(campoQuantExtra);
        sendKeys(campoQuantExtra, "6");
        clear(campoQuantDevolvida);
        sendKeys(campoQuantDevolvida, "4,5");
        click(campoQuantExtra);

        String quantConsumida = driver.findElement(campoQuantConsumida).getAttribute("value");
        Assert.assertEquals(quantConsumida, "1,50000", "Verificação do valor de quantidade consumida após preencher os campos anteriores");
        click(botaoSalvar);

        clicarCampoSelecionarValor(campoAlmoxarifado, almoxarifadoProdAcabadoAprovado);
        if (mensagemRetiraEsperada == "Salvo com sucesso.") clicarCampoSelecionarValor(campoLote, loteQuerosene);
        else if (mensagemRetiraEsperada == "Já existe item cadastrado.") clicarCampoSelecionarValor(campoLote, loteQueroseneMenosQuant);

        click(botaoConfirmar);

        String mensagemRetiraEncontrada = getText(campoMensagemAlerta);
        Assert.assertEquals(mensagemRetiraEncontrada, mensagemRetiraEsperada, "Verificação da mensagem exibida na tela após concluir o formulário de retirada do produto");
        click(botaoOkAlerta);
    }

    public void verificarRetiradaProduto() {
        click(nomeProdLinha1);

        //valores encontrados
        String encQuantExtra = driver.findElement(campoQuantExtraProd).getAttribute("value");
        String encQuantDevolvida = driver.findElement(campoQuantDevolvidaProd).getAttribute("value");
        String encQuantConsumida = driver.findElement(campoQuantConsumidaProd).getAttribute("value");

        //valores esperados
        String expQuantExtra = "4,00000";
        String expQuantDevolvida = "2,00000";
        String expQuantConsumida = "2,00000";

        Assert.assertEquals(encQuantExtra, expQuantExtra, "Verificação do valor da quantidade extra na retirada do produto");
        Assert.assertEquals(encQuantDevolvida, expQuantDevolvida, "Verificação do valor da quantidade devolvida na retirada do produto");
        Assert.assertEquals(encQuantConsumida, expQuantConsumida, "Verificação do valor da quantidade consumida na retirada do produto");
        click(botaoCancelar);
    }

    public void verificarSegundaRetiradaProduto() {
        click(nomeProdLinha2);

        //valores encontrados
        String encQuantExtra = driver.findElement(campoQuantExtraProd).getAttribute("value");
        String encQuantDevolvida = driver.findElement(campoQuantDevolvidaProd).getAttribute("value");
        String encQuantConsumida = driver.findElement(campoQuantConsumidaProd).getAttribute("value");

        //valores esperados
        String expQuantExtra = "6,00000";
        String expQuantDevolvida = "4,50000";
        String expQuantConsumida = "1,50000";

        Assert.assertEquals(encQuantExtra, expQuantExtra, "Verificação do valor da quantidade extra na retirada do segundo produto");
        Assert.assertEquals(encQuantDevolvida, expQuantDevolvida, "Verificação do valor da quantidade devolvida na retirada do segundo produto");
        Assert.assertEquals(encQuantConsumida, expQuantConsumida, "Verificação do valor da quantidade consumida na retirada do segundo produto");
        click(botaoCancelar);
    }

    public void editarRetiradaProduto() {
        click(nomeProdLinha2);
        click(campoQuantConsumidaProd);
        clear(campoQuantConsumidaProd);

        click(campoQuantExtraProd);
        clear(campoQuantExtraProd);
        sendKeys(campoQuantExtraProd, "5");

        click(campoQuantDevolvidaProd);
        clear(campoQuantDevolvidaProd);
        sendKeys(campoQuantDevolvidaProd, "4");
        click(campoQuantExtraProd);

        String encQuantConsumida = driver.findElement(campoQuantConsumidaProd).getAttribute("value");
        String expQuantConsumida = "1,00000";
        Assert.assertEquals(encQuantConsumida, expQuantConsumida, "Verificação do valor da quantidade consumida, após editar a quantidade extra e devolvida");
        click(botaoSalvar);
        clicarCampoSelecionarValor(campoAlmoxarifado, almoxarifadoProdAcabadoAprovado);
        clicarCampoSelecionarValor(campoLote, loteQueroseneMenosQuant    );
        click(botaoConfirmar);

        String mensagemEncontrada = getText(campoMensagemAlerta);
        String mensagemEsperada = "Salvo com sucesso.";
        Assert.assertEquals(mensagemEncontrada, mensagemEsperada, "Verificação da mensagem exibida na tela após fazer a editar da quatidade retirado do produto");
        click(botaoOkAlerta);

        click(nomeProdLinha2);

        //valores encontrados após a edição
        String encQuantExtra = driver.findElement(campoQuantExtraProd).getAttribute("value");
        String encQuantDevolvida = driver.findElement(campoQuantDevolvida).getAttribute("value");
        encQuantConsumida = driver.findElement(campoQuantConsumidaProd).getAttribute("value");

        //valores esperados após a edição
        String expQuantExtra = "5,00000";
        String expQuantDevolvida = "4,00000";
        expQuantConsumida = "1,00000";

        Assert.assertEquals(encQuantExtra, expQuantExtra, "Verificação do valor da quantidade extra, após a edição ter sido salva");
        Assert.assertEquals(encQuantDevolvida, expQuantDevolvida, "Verificação do valor da quantidade devolvida, após a edição ter sido salva");
        Assert.assertEquals(encQuantConsumida, expQuantConsumida, "Verificação do valor da quantidade consumida, após a edição ter sido salva");
        click(botaoCancelar);
    }

    public void addRetProdutoCamposVazios() {
        click(campoQuantExtraProd);
        click(campoQuantDevolvidaProd);
        click(campoQuantConsumidaProd);
        click(botaoLimparTipoRetirada);
        click(botaoSalvar);

        String produtoOb = getText(mensagemObrigatorioProduto);
        String quantExtraOb = getText(mensagemObrigatorioQuantExtra);
        String quantDevolvidaOb = getText(mensagemObrigatorioQuantDevolvida);
        String quantConsumidaOb = getText(mensagemObrigatorioQuantConsumida);
        String tipoRetiradaOb = getText(mensagemObrigatorioTipoRetirada);

        String mensagemEsperada = "Campo obrigatório";
        Assert.assertEquals(produtoOb, mensagemEsperada, "Verificação da mensagem de campo obrigatório do campo 'produto' no formulário de cadastro da retirada de produto");
        Assert.assertEquals(quantExtraOb, mensagemEsperada, "Verificação da mensagem de campo obrigatório do campo 'quantidade extra' no formulário de cadastro da retirada de produto");
        Assert.assertEquals(quantDevolvidaOb, mensagemEsperada, "Verificação da mensagem de campo obrigatório do campo 'quantidade devolvida' no formulário de cadastro da retirada de produto");
        Assert.assertEquals(quantConsumidaOb, mensagemEsperada, "Verificação da mensagem de campo obrigatório do campo 'quantidade consumida' no formulário de cadastro da retirada de produto");
        Assert.assertEquals(tipoRetiradaOb, mensagemEsperada, "Verificação da mensagem de campo obrigatório do campo 'tipo retirada' no formulário de cadastro da retirada de produto");

        Actions actions = new Actions(driver);
        actions.moveToElement(driver.findElement(campoProduto), -200, 0).click().build().perform();
        click(produtoOleoAmendoasDoces);

        actions.moveToElement(driver.findElement(campoTipoRetirada), -200, 0).click().build().perform();
        click(tipoRetiradaConsumoProducao);

        actions.moveToElement(driver.findElement(campoQuantExtra), -200, 0).click().build().perform();
        sendKeys(campoQuantExtra, "4,5");

        actions.moveToElement(driver.findElement(campoQuantDevolvida), -200, 0).click().build().perform();
        sendKeys(campoQuantDevolvida, "3");
        click(campoQuantExtra);

        //valor do campo quantidade consumida após inserir o valor da quantidade extra e devolvida
        String encQuantConsuida = driver.findElement(campoQuantConsumida).getAttribute("value");
        String expQuantConsumida = "1,50000";
        Assert.assertEquals(encQuantConsuida, expQuantConsumida, "Verificação do campo quantidade consumida após inserir o valor da quantidade extra e devolvida");

        click(botaoSalvar);
        click(botaoLimparAlmoxarifado);
        click(botaoConfirmar);

        String mensagemAlmoxarifado = getText(mensagemObrigatorioAlmoxarifado);
        String mensagemLote = getText(mensagemObrigatorioLote);
        Assert.assertEquals(mensagemAlmoxarifado, mensagemEsperada, "Verificação da mensagem de campo obrigatório no campo 'almoxarifado', após tentar confirmar com o campo vazio");
        Assert.assertEquals(mensagemLote, mensagemEsperada, "Verificação da mensagem de campo obrigatório no campo 'lote', após tentar confirmar com o campo vazio");

        actions.moveToElement(driver.findElement(campoAlmoxarifado), -200, 0).click().build().perform();
        click(almoxarifadoProdAcabadoAprovado);

        tempo();
        actions.moveToElement(driver.findElement(campoLote), -200, 0).click().build().perform();
        click(loteOleaoAmendoasDoces);
        click(botaoConfirmar);

        String mensagemRetiraEsperada = "Retirada incluída com sucesso, porém ocorreram erros durante a evolução do estoque, verifique o log.";
        String mensagemRetiraEncontrada = getText(campoMensagemAlerta);
        Assert.assertEquals(mensagemRetiraEncontrada, mensagemRetiraEsperada, "Verificação da mensagem exibida na tela após concluir o formulário de retirada do produto");
        click(botaoOkAlerta);
    }

    public void cancelarRetirada() {
        tempo();
        click(botaoCancelar);

        //valores encontrados
        String encServico = getText(campoServico);
        String encDataRetirada = driver.findElement(campoDataRetirada).getAttribute("value");

        //valores esperados
        String expServico = "00002 | ALMOÇO ESPECIAL";
        String expDataRetirada = "31/08/2022";

        Assert.assertEquals(encServico, expServico, "Verificação do valor do campo serviço, após cancelar a retirada e retornar para o formulário de nova retirada");
        Assert.assertEquals(encDataRetirada, expDataRetirada, "Verificação do valor do campo data retirada, após cancelar a retirada e retornar para o formulário de nova retirada");
    }

    public void escreverValorNoCampoProcurarReiradaTipoPrato() {
        click(botaoPesquisarTipoPrato);
        sendKeys(campoProcurar, "CAFÉ DA MANHÃ");
        click(resultPesqTipoPratoCafeManha);

        click(botaoPesquisarPrato);
        sendKeys(campoProcurar, "PÃO DE QUEIJO");
        click(resultPesqPratoPaoDeQueijo);

        click(botaoPesquisarProduto);
        sendKeys(campoProcurar, "CENTELLA ASIATICA (FOLHAS)");
        click(resultPesqCentelaAsiatica);

        click(botaoLimparTipoRetirada);
        click(botaoPesquisarTipoRetirada);
        sendKeys(campoProcurar, "CONSUMO DE PRODUÇÃO");
        click(resultPesqTipoRetiradaConsumoProducao);

        //Valores encontrados nos campos após a pesquisa
        String encTipoPrato = getText(campoTipoPrato);
        String encPrato = getText(campoPrato);
        String encProduto = getText(campoProduto);
        String encTipoRetirada = getText(campoTipoRetirada);

        //valores esperados
        String expTipoPrato = "07 | CAFÉ DA MANHÃ";
        String expPrato = "02.00.00.000 | PÃO DE QUEIJO";
        String expProduto = "1.01.3.1.06.004.00 | CENTELLA ASIATICA (FOLHAS)";
        String expTipoRetirada = "01 | CONSUMO DE PRODUÇÃO";

        Assert.assertEquals(encTipoPrato, expTipoPrato, "Verificação do valor do campo 'tipo prato', após ser feita a busca escrevendo o nome do mesmo no campo procurar");
        Assert.assertEquals(encPrato, expPrato, "Verificação do valor do campo 'prato', após ser feita a busca escrevendo o nome do mesmo no campo procurar");
        Assert.assertEquals(encProduto, expProduto, "Verificação do valor do campo 'produto', após ser feita a busca escrevendo o nome do mesmo no campo procurar");
        Assert.assertEquals(encTipoRetirada, expTipoRetirada, "Verificação do valor do campo 'tipo retirada', após ser feita a busca escrevendo o nome da mesma no campo procurar");
    }

    public void escreverValorNoCampoProcurarReiradaProduto() {
        click(botaoPesquisarProduto);
        sendKeys(campoProcurar, "CENTELLA ASIATICA (FOLHAS)");
        click(resultPesqCentelaAsiatica);

        click(botaoLimparTipoRetirada);
        click(botaoPesquisarTipoRetirada);
        sendKeys(campoProcurar, "CONSUMO DE PRODUÇÃO");
        click(resultPesqTipoRetiradaConsumoProducao);

        //Valores encontrados nos campos após a pesquisa
        String encProduto = getText(campoProduto);
        String encTipoRetirada = getText(campoTipoRetirada);

        //valores esperados
        String expProduto = "1.01.3.1.06.004.00 | CENTELLA ASIATICA (FOLHAS)";
        String expTipoRetirada = "01 | CONSUMO DE PRODUÇÃO";

        Assert.assertEquals(encProduto, expProduto, "Verificação do valor do campo 'produto', após ser feita a busca escrevendo o nome do mesmo no campo procurar");
        Assert.assertEquals(encTipoRetirada, expTipoRetirada, "Verificação do valor do campo 'tipo retirada', após ser feita a busca escrevendo o nome da mesma no campo procurar");
    }

    public void editarQuantExtraTelaPrincipal() {
        tempo();
        Actions actions = new Actions(driver);
        actions.moveToElement(driver.findElement(quantExtraTelaPrinciapal)).click().build().perform();
        tempo();
        actions.sendKeys(Keys.BACK_SPACE).build().perform();
        tempo();
        actions.sendKeys("7,5").build().perform();
        tempo();
        actions.sendKeys(Keys.ENTER).build().perform();


        clicarCampoSelecionarValor(campoAlmoxarifado, almoxarifadoProdAcabadoAprovado);
        clicarCampoSelecionarValor(campoLote, loteOleaoAmendoasDocesMenosQuant);
        click(botaoConfirmar);
        String mensagemEsperada = "Salvo com sucesso.";
        String mensagem = getText(campoMensagemAlerta);
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem após salvar o tipo prato/produto");
        click(botaoOkAlerta);
    }

    public void varificarValoresAposEdicaoTelaPrincipal(String aposEdicao) {
        tempo();
        //valores encontrados
        String encQuantExtra = getText(quantExtraTelaPrinciapal);
        String encQuantDevolvida = getText(quantDevolvidaTelaPrinciapl);
        String encQuantConsumida = getText(quantConsumidaTelaPrincipal);

        String expQuantExtra = "";
        String expQuantConsumida = "";
        String expQuantDevolvida = "";

        //valores encontrados
        if (aposEdicao == "Quantidade Extra") {
            expQuantExtra = "7,50000";
            expQuantDevolvida = "2,00000";
            expQuantConsumida = "5,50000";
        } else if (aposEdicao == "Quantidade Consumida") {
            expQuantExtra = "3,00000";
            expQuantDevolvida = "0,00000";
            expQuantConsumida = "3,00000";
        }

        Assert.assertEquals(encQuantExtra, expQuantExtra, "Varificação do valor da quantidade extra, após a edição da " + aposEdicao + " ser feita na tela inicial");
        Assert.assertEquals(encQuantDevolvida, expQuantDevolvida, "Varificação do valor da quantidade devolvida, após a edição da " + aposEdicao + " ser feita na tela inicial");
        Assert.assertEquals(encQuantConsumida, expQuantConsumida, "Varificação do valor da quantidade consumida, após a edição da " + aposEdicao + " ser feita na tela inicial");
    }

    public void editarQuantConsumidaTelaPrincipal() {
        tempo();
        Actions actions = new Actions(driver);
        actions.moveToElement(driver.findElement(quantConsumidaTelaPrincipal)).click().build().perform();
        tempo();
        actions.sendKeys(Keys.BACK_SPACE).build().perform();
        tempo();
        actions.sendKeys("3").build().perform();
        tempo();
        actions.sendKeys(Keys.ENTER).build().perform();

        clicarCampoSelecionarValor(campoAlmoxarifado, almoxarifadoProdAcabadoAprovado);
        clicarCampoSelecionarValor(campoLote, loteOleaoAmendoasDocesEditInLine);
        click(botaoConfirmar);
        String mensagemEsperada = "Salvo com sucesso.";
        String mensagem = getText(campoMensagemAlerta);
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem após salvar o tipo prato/produto");
        click(botaoOkAlerta);
    }

}
